
global MAIN_DICT_s10_100g_0
global BASE_HTILE_HIP
dict set MAIN_DICT_s10_100g_0 OFFSET_S10CSR 0x0
dict set MAIN_DICT_s10_100g_0 OFFSET_S10RECO 0x10000

global ip_sub_variant_option
global freeze1
global freeze2
global freeze3
global freeze4
global freeze5
global freeze6
global freeze7

global textbox_freeze1
global textbox_freeze2
global textbox_freeze3
global textbox_freeze4
global textbox_freeze5
global textbox_freeze6
global textbox_freeze7
global iadpt_set

set BASE_HTILE_HIP 0x0


proc reconfig_reg_read {chan addr offset} {
       
    set chanoffs [expr $offset + (0x01000 * $chan)]
    return [reg_read $chanoffs $addr]
}

proc reconfig_reg_write {chan addr offset val} {
        
    set chanoffs [expr $offset + (0x01000 * $chan)]
    return [reg_write $chanoffs $addr $val]
}

proc reconfig_reg_rmw {chan addr offset mask val} {
    set value [reconfig_reg_read $chan $addr $offset]
    set value [expr $value & [expr 0xffffffff & ~$mask]] 
    set value [expr $value | $val] 
    reconfig_reg_write $chan $addr $offset $value
}

proc widenum {upper32 lower32} {
    set multi [expr {pow(2,32)}];
    set up_conv [expr {$upper32 * $multi}];
    set temp [expr {$up_conv + $lower32}];
    return [expr {entier($temp)}];
}

proc stats_read {base loffset} {
    set hoffset [ expr $loffset + 1 ]

    set low_data [ reg_read $base $loffset ]
    set hi_data  [ reg_read $base $hoffset ]
    set data [ expr { ($hi_data << 32) + $low_data } ]
    return $data
}

proc dashboard_s10_100g_0 {} {
	global dash
	global anlt_enabled
	global ip_sub_variant_option
	global htile_prod_enabled
	
	if {$ip_sub_variant_option == "100g_nrz"} {
	widget_group 1  topGroup ip_tab 1 "Intel Stratix 10 H-Tile Hard IP for Ethernet 100G - NRZ"
	} else {
	widget_group 1  topGroup ip_tab 1 "Intel Stratix 10 H-Tile Hard IP for Ethernet 50G - NRZ"
	}
	
		widget_checkBox 1  continuous_read topGroup "Continuous Read All Registers" proc_continuous_read
		
			widget_group 1 tx_rx_status topGroup 5 ""
				widget_label 1 txpcsready_htile_hip tx_rx_status "TX PCS Ready"
				widget_led 1 txpcsready_stat tx_rx_status "" black 	
				widget_label 1 dummy_space tx_rx_status "         "
				widget_label 1 rxpcsaligned_htile_hip tx_rx_status "RX PCS Aligned"
				widget_led 1 rxpcs_stat tx_rx_status "" black	
		
		dashboard_add $dash allstatus tabbedGroup topGroup
	
			#
			#MAC & PCS
			#
			widget_group 1  MAC_PCS allstatus 1 "MAC & PCS"
			
				widget_group 1  reset_mac_pcs MAC_PCS 3 "Resets"
					widget_button 1 full_sys_rst reset_mac_pcs "Assert Full System Reset" proc_full_sys_rst
					widget_button 1 soft_txp_rst reset_mac_pcs "Assert TX MAC & PCS Reset" proc_soft_txp_rst
					widget_button 1 soft_rxp_rst reset_mac_pcs "Assert RX MAC & PCS Reset" proc_soft_rxp_rst
					
				widget_group 1  PCS MAC_PCS 2 "PCS Status"
					
						widget_button 1 read_pcs_status PCS "Read PCS Status" proc_read_pcs_status
						widget_button 1 eio_sloop PCS "Enable Serial PMA Loopback" proc_eio_sloop
						#widget_label 1 eio_sloop_dummy PCS "" 
						#widget_checkBox 1 ignore_nonce PCS "Ignore Nonce" ignore_nonce_check
					
					widget_group 1  PCS_2 PCS 2 ""	
						
						widget_label 1  txclk_title PCS_2 "TX Clock (KHz)"
						widget_textBox 1  txclk_stat PCS_2 0 "0" 7 175
						
						widget_label 1  rxclk_title PCS_2 "RX Clock (KHz)"
						widget_textBox 1  rxclk_stat PCS_2 0 "0" 7 175
											
						widget_label 1  frameerror_title PCS_2 "Frame Error"
						widget_textBox 1  frameerror_stat PCS_2 0 "0" 7 175
						
						widget_label 1 bercount PCS_2 "BER Count"
						widget_textBox 1 bercount_value PCS_2 0 "0x00000000" 7 175
					
						widget_label 1 hiber PCS_2 "Hi-BER"
						widget_textBox 1 hiber_value PCS_2 0 "Not Detected" 7 175
			
						widget_label 1  amlock PCS_2 "Alignment Marker Lock"
						widget_led 1 amlock_stat PCS_2 ""  black
												
						

					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_group 1  pcs_dummy_1 PCS 5 ""
					} else {
					widget_group 1  pcs_dummy_1 PCS 3 ""
					}
						
						widget_label 1   pcs_dummy_1_blank pcs_dummy_1 ""
						widget_label 1   pcs_dummy_1_l0 pcs_dummy_1 "Lane 0"
						widget_label 1   pcs_dummy_1_l1 pcs_dummy_1 "Lane 1"
						if {$ip_sub_variant_option == "100g_nrz"} {
						widget_label 1   pcs_dummy_1_l2 pcs_dummy_1 "Lane 2"
						widget_label 1   pcs_dummy_1_l3 pcs_dummy_1 "Lane 3"
						}
						
						widget_label 1  tx_pma_clock_locked pcs_dummy_1 "TX PMA Clock Locked"
						widget_led 1 tx_pma_clock_locked_l0 pcs_dummy_1 ""  black
						widget_led 1 tx_pma_clock_locked_l1 pcs_dummy_1 ""  black
						if {$ip_sub_variant_option == "100g_nrz"} {
						widget_led 1 tx_pma_clock_locked_l2 pcs_dummy_1 ""  black
						widget_led 1 tx_pma_clock_locked_l3 pcs_dummy_1 ""  black
						}
						
						widget_label 1  rxcdrplllocked pcs_dummy_1 "RX CDR PLL Locked"
						widget_led 1 rxcdrplllocked_l0 pcs_dummy_1 ""  black
						widget_led 1 rxcdrplllocked_l1 pcs_dummy_1 ""  black
						if {$ip_sub_variant_option == "100g_nrz"} {
						widget_led 1 rxcdrplllocked_l2 pcs_dummy_1 ""  black
						widget_led 1 rxcdrplllocked_l3 pcs_dummy_1 ""  black
						}

						
					
				widget_group 1  MAC MAC_PCS 2 ""
				
					widget_group 1  TXMAC MAC 2 "TX MAC Status"
					
						widget_button 1 read_txmac_status_htile_hip TXMAC "Read TX MAC Status" proc_read_txmac_status_htile_hip
						widget_label 1 blank_txmac_status_htile_hip TXMAC ""
						
						widget_label 1 force_remote_fault_htile_hip TXMAC "Force Remote Fault"
						widget_textBox 1 force_remote_fault_text_htile_hip TXMAC 0 "Off" 7 250
							
						widget_label 1 disable_remote_fault_htile_hip TXMAC "Disable Remote Fault"
						widget_textBox 1 disable_remote_fault_text_htile_hip TXMAC 0 "Off" 7 250
							
						widget_label 1 unidir_remote_link_fault_reporting_htile_hip TXMAC "Unidirectional Link Fault Reporting"
						widget_textBox 1 unidir_remote_link_fault_reporting_text_htile_hip TXMAC 0 "Off" 7 250
							
						widget_label 1 link_fault_reporting_htile_hip TXMAC "Link Fault Reporting"
						widget_textBox 1 link_fault_reporting_text_htile_hip TXMAC 0 "On" 7 250
							
						widget_label 1 idle_col_rem_htile_hip TXMAC "IPG Words removed per AM Period"
						widget_textBox 1 idle_col_rem_text_htile_hip TXMAC 0 "0x00000000" 7 250
							
						widget_label 1 max_tx_size_config_htile_hip TXMAC "Max TX Size Config"
						widget_textBox 1 max_tx_size_config_text_htile_hip TXMAC 0 "0x00000000" 7 250
							
						widget_label 1 en_saddr_insert_htile_hip TXMAC "Source Address Insertion"
						widget_textBox 1 en_saddr_insert_text_htile_hip TXMAC 0 "Client provides Source Address" 7 250
						
						widget_label 1 saddrh_htile_hip TXMAC "Upper 2 bytes of Source Address"
						widget_textBox 1 saddrh_text_htile_hip TXMAC 0 "0x00000000" 7 250
						
						widget_label 1 saddrl_htile_hip TXMAC "Lower 4 bytes of Source Address"
						widget_textBox 1 saddrl_text_htile_hip TXMAC 0 "0x00000000" 7 250
						
						widget_label 1 vlan_detection_tx_htile_hip TXMAC "VLAN Detection for TX Stats"
						widget_textBox 1 vlan_detection_tx_text_htile_hip TXMAC 0 "Disabled" 7 250
							
						widget_label 1 txcrc_covers_preamble_htile_hip TXMAC "TX CRC over preamble"
						widget_textBox 1 txcrc_covers_preamble_text_htile_hip TXMAC 0 "Off" 7 250
							
						widget_label 1 ipg_htile_hip TXMAC "DIC Average Min IPG"
						widget_textBox 1 ipg_text_htile_hip TXMAC 0 "12 bytes" 7 250
							
						widget_label 1 en_pp_tx_htile_hip TXMAC "TX Preamble Passthrough"
						widget_textBox 1 en_pp_tx_text_htile_hip TXMAC 0 "Disabled" 7 250
						
					widget_group 1  RXMAC MAC 2 "RX MAC Status"
					
						widget_button 1 read_rxmac_status_htile_hip RXMAC "Read RX MAC Status" proc_read_rxmac_status_htile_hip
						widget_label 1 blank_rxmac_status_htile_hip RXMAC ""
						
						widget_label 1 max_rx_size_config_htile_hip RXMAC "MAX RX Size Config"
						widget_textBox 1 max_rx_size_config_text_htile_hip RXMAC 0 "00000000" 7 300
							
						widget_label 1 mac_crc_config_htile_hip RXMAC "RX CRC Forwarding"
						widget_textBox 1 mac_crc_config_text_htile_hip RXMAC 0 "Remove CRC from RX frames" 7 300
							
						widget_label 1 remote_fault_htile_hip RXMAC "Remote Fault"
							dashboard_set_property $dash remote_fault_htile_hip foregroundColor black
						widget_textBox 1 remote_fault_text_htile_hip RXMAC 0 "No" 7 300
							
						widget_label 1 local_fault_htile_hip RXMAC "Local Fault"
							dashboard_set_property $dash local_fault_htile_hip foregroundColor black
						widget_textBox 1 local_fault_text_htile_hip RXMAC 0 "No" 7 300
							
						widget_label 1 remove_rx_pad_htile_hip RXMAC "Remove PADs from padded frames"
						widget_textBox 1 remove_rx_pad_text_htile_hip RXMAC 0 "Off" 7 300
							
						widget_label 1 enforce_max_rx_htile_hip RXMAC "Enforce Maximum frame size on RX packets"
						widget_textBox 1 enforce_max_rx_text_htile_hip RXMAC 0 "Ovesized frames are not altered" 7 300
							
						widget_label 1 preamble_check_htile_hip RXMAC "Strict Preamble Checking"
						widget_textBox 1 preamble_check_text_htile_hip RXMAC 0 "Off" 7 300
							
						widget_label 1 sfd_check_htile_hip RXMAC "SFD Checking"
						widget_textBox 1 sfd_check_text_htile_hip RXMAC 0 "Off" 7 300
							
						widget_label 1 vlan_detection_rx_htile_hip RXMAC "RX VLAN Detection"
						widget_textBox 1 vlan_detection_rx_text_htile_hip RXMAC 0 "Enabled" 7 300
							
						widget_label 1 en_plen_htile_hip RXMAC "Packet Length Checking"
						widget_textBox 1 en_plen_text_htile_hip RXMAC 0 "On" 7 300
							
						widget_label 1 rxcrc_covers_preamble_htile_hip RXMAC "RX CRC over preamble"
						widget_textBox 1 rxcrc_covers_preamble_text_htile_hip RXMAC 0 "RX CRC calculated over Ethernet Frame" 7 300
							
						widget_label 1 en_pp_rx_htile_hip RXMAC "RX Preamble Passthrough"
						widget_textBox 1 en_pp_rx_text_htile_hip RXMAC 0 "Disabled" 7 300	
						
			widget_groupHeight 1 mac_and_pcs_status_dummygroup MAC_PCS 1 "" 650
			
			#
			#Statistics Counters
			#
			widget_group 1  PKT_STATS_COUNT allstatus 1 "Statistics Counters"
			
			packet_generator
				# widget_group 1 PKT_STATS_CNTRL PKT_STATS_COUNT 1 "Packet Generator - only available when using design example"
				
					# widget_group 1 pkt_cont  PKT_STATS_CNTRL 2 ""
					
					# widget_checkBox 1 pkt_cntrl_en pkt_cont "Quartus generated Design Example used" proc_pkt_cntrl_en
					# dashboard_set_property $dash pkt_cntrl_en toolTip "When using design example, select JTAG Master with name 'jtag_master' (and not 'jtag_master_alt_e100s10') to use packet generator"
					# widget_checkBox 1  mac_loopback pkt_cont "MAC Loopback Mode" proc_mac_loopback
					# dashboard_set_property $dash mac_loopback enabled false	
					
					# widget_group 1 Source_Dest_Address PKT_STATS_CNTRL 3 ""
						
						# widget_button 1 set_source_add Source_Dest_Address "Set Source Address      " proc_set_source_add
						# dashboard_set_property $dash set_source_add enabled false	
						# widget_textBox 1 source_Add Source_Dest_Address 0 "0x976543210ADD" 10 150
						# widget_label 1 range_source Source_Dest_Address "Range: 0x0 to 0xFFFFFFFFFFFF"
						
						# widget_button 1 set_dest_add Source_Dest_Address "Set Destination Address" proc_set_dest_add
						# dashboard_set_property $dash set_dest_add enabled false	
						# widget_textBox 1 dest_Add Source_Dest_Address 0 "0x123456780ADD" 10 150
						# widget_label 1 range_dest Source_Dest_Address "Range: 0x0 to 0xFFFFFFFFFFFF"
										
						
					# widget_group 1 PKT_CNTRL PKT_STATS_CNTRL 3 ""
					
								
					# widget_group 1  random_mode PKT_CNTRL 2 "Random Mode"
						# widget_label 1  random_gap random_mode "Random Gap"
						# widget_button 1 pkt_gen_random_gap random_mode "Start Packet Generator" proc_pkt_gen_random_gap
						# dashboard_set_property $dash pkt_gen_random_gap enabled false	
						
						# widget_label 1  no_gap random_mode "No Gap (Full Rate)"
						# widget_button 1 pkt_gen_no_gap random_mode "Start Packet Generator" proc_pkt_gen_no_gap
						# dashboard_set_property $dash pkt_gen_no_gap enabled false	
						
					# widget_group 1  fixed_mode PKT_CNTRL 3 "Fixed Mode"
						# widget_label 1  pkt_byte_size fixed_mode "Packet Byte Size"
						# widget_textBox 1  pkt_byte_size_val fixed_mode 0 "0x0040" 10 75
						# widget_label 1  pkt_byte_range fixed_mode "Range 0x0040 - 0x2580"
						
						# widget_label 1  pkt_num fixed_mode "Total no. of Packets"
						# widget_textBox 1  pkt_num_val fixed_mode 0 "0x0000000A" 10 75
						# widget_label 1  pkt_num_blank fixed_mode ""
						
						# widget_button 1 pkt_gen_fixed fixed_mode "Start Packet Generator" proc_pkt_gen_fixed
						# dashboard_set_property $dash pkt_gen_fixed enabled false	
		
						
					# widget_group 1  incr_mode PKT_CNTRL 3 "Incremental Mode"
						# widget_label 1  pkt_byte_size_begin incr_mode "Packet Byte Size - Begin"
						# widget_textBox 1  pkt_byte_size_begin_val incr_mode 0 "0x0040" 10 75
						# widget_label 1  pkt_byte_begin_range incr_mode "Range 0x0040 - 0x2575"
						
						# widget_label 1  pkt_byte_size_end incr_mode "Packet Byte Size - End"
						# widget_textBox 1  pkt_byte_size_end_val incr_mode 0 "0x2580" 10 75
						# widget_label 1  pkt_byte_end_range incr_mode "Range 0x0041 - 0x2580"
						
						# widget_label 1  pkt_incr_num incr_mode "Total no. of Packets"
						# widget_textBox 1  pkt_incr_num_val incr_mode 0 "0x0000000A" 10 75
						# widget_label 1  pkt_incr_num_blank incr_mode ""
						
						# widget_button 1 pkt_gen_incr incr_mode "Start Packet Generator" proc_pkt_gen_incr
						# dashboard_set_property $dash pkt_gen_incr enabled false
						
						
				
				widget_group 1  STATS_COUNT_UP PKT_STATS_COUNT 2 ""
				widget_group 1  STATS_COUNT STATS_COUNT_UP 3 "TX & RX Statistics"
				#widget_button 1 pkt_gen STATS_COUNT "Start Packet Generator" proc_pkt_gen
				#widget_label 1  pkt_gen_note STATS_COUNT "Note: Only available when example design is instantiated"
				
				widget_label 1 name_stats_count  STATS_COUNT "Statistics Counters Names"
					widget_label 1 txmac_stats_hip  STATS_COUNT "TX Statistics Counters"
					widget_label 1 rxmac_stats_hip  STATS_COUNT "RX Statistics Counters"
				
					widget_label 1 read_statistics_hip  STATS_COUNT ""				
					widget_button 1 read_tx_stats STATS_COUNT "Read TX Statistics" proc_read_tx_stats
					widget_button 1 read_rx_stats STATS_COUNT "Read RX Statistics" proc_read_rx_stats
					
					widget_label 1 reset_statistics_hip  STATS_COUNT ""				
					widget_button 1 reset_tx_stats STATS_COUNT "Reset TX Statistics" proc_reset_tx_stats
					widget_button 1 reset_rx_stats STATS_COUNT "Reset RX Statistics" proc_reset_rx_stats
												
					widget_label 1 cntr_tx_fragments STATS_COUNT "Frames < 64 bytes with CRC error"
					widget_textBox 1 cntr_tx_fragments_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_fragments_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_jabbers STATS_COUNT "Oversized frames with CRC error"
					widget_textBox 1 cntr_tx_jabbers_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_jabbers_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_fcs STATS_COUNT "Frames of any size with a CRC error"
					widget_textBox 1 cntr_tx_fcs_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_fcs_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_fcs_err_okpkt STATS_COUNT "Frames of any size with a CRC error on OK packet"
					widget_textBox 1 cntr_tx_fcs_err_okpkt_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_fcs_err_okpkt_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_data_err STATS_COUNT "Multicast data frames with CRC error"
					widget_textBox 1 cntr_tx_mcast_data_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_data_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_data_err STATS_COUNT "Broadcast data frames with CRC error"
					widget_textBox 1 cntr_tx_bcast_data_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_data_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_data_err STATS_COUNT "Unicast data frames with CRC error"
					widget_textBox 1 cntr_tx_ucast_data_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_data_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_ctrl_err STATS_COUNT "Multicast Control frames with CRC error"
					widget_textBox 1 cntr_tx_mcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_ctrl_err STATS_COUNT "Broadcast Control frames with CRC error"
					widget_textBox 1 cntr_tx_bcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_ctrl_err STATS_COUNT "Unicast Control frames with CRC error"
					widget_textBox 1 cntr_tx_ucast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_pause_err STATS_COUNT "Pause frame with CRC error"
					widget_textBox 1 cntr_tx_pause_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_pause_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_64b STATS_COUNT "64 Byte Frames"
					widget_textBox 1 cntr_tx_64b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_64b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_65to127b STATS_COUNT "65 - 127 Byte Frames"
					widget_textBox 1 cntr_tx_65to127b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_65to127b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_128to255b STATS_COUNT "128 - 255 Byte Frames"
					widget_textBox 1 cntr_tx_128to255b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_128to255b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_256to511b STATS_COUNT "256 - 511 Byte Frames"
					widget_textBox 1 cntr_tx_256to511b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_256to511b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_512to1023b STATS_COUNT "512 - 1023 Byte Frames"
					widget_textBox 1 cntr_tx_512to1023b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_512to1023b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_1024to1518b STATS_COUNT "1024 - 1518 Byte Frames"
					widget_textBox 1 cntr_tx_1024to1518b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_1024to1518b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_1519tomaxb STATS_COUNT "1519 - MAX Size Frames"
					widget_textBox 1 cntr_tx_1519tomaxb_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_1519tomaxb_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_oversize STATS_COUNT "Oversize Frames (> MAX Size Frames)"
					widget_textBox 1 cntr_tx_oversize_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_oversize_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_data_ok STATS_COUNT "Multicast data frames without error"
					widget_textBox 1 cntr_tx_mcast_data_ok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_data_ok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_data_ok STATS_COUNT "Broadcast data frames without error"
					widget_textBox 1 cntr_tx_bcast_data_ok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_data_ok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_data_ok STATS_COUNT "Unicast data frames without error"
					widget_textBox 1 cntr_tx_ucast_data_ok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_data_ok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_mcast_ctrl STATS_COUNT "Multicast Control frames without error"
					widget_textBox 1 cntr_tx_mcast_ctrl_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_ctrl_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_bcast_ctrl STATS_COUNT "Broadcast Control frames without error"
					widget_textBox 1 cntr_tx_bcast_ctrl_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_ctrl_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_ucast_ctrl STATS_COUNT "Unicast Control frames without error"
					widget_textBox 1 cntr_tx_ucast_ctrl_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_ctrl_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_pause STATS_COUNT "Pause frames without error"
					widget_textBox 1 cntr_tx_pause_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_pause_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_runt STATS_COUNT "Frames with < 64 bytes and a CRC error"
					widget_textBox 1 cntr_tx_runt_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_runt_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_st STATS_COUNT "Number of frame starts"
					widget_textBox 1 cntr_tx_st_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_st_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_lenerr STATS_COUNT "Number of length error"
					widget_textBox 1 cntr_tx_lenerr_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_lenerr_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_pfc_err STATS_COUNT "PFC frame with CRC error"
					widget_textBox 1 cntr_tx_pfc_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_pfc_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_pfc STATS_COUNT "PFC frame without error"
					widget_textBox 1 cntr_tx_pfc_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_pfc_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_payloadoctetsok STATS_COUNT "Payload bytes with no errors"
					widget_textBox 1 cntr_tx_payloadoctetsok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_payloadoctetsok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 txoctetsok STATS_COUNT "Frame bytes with no errors"
					widget_textBox 1 txoctetsok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 rxoctetsok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_malformed STATS_COUNT "Malformed frames"
					widget_textBox 1 cntr_tx_malformed_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_malformed_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_dropped STATS_COUNT "TX Frames that were dropped due to error"
					widget_textBox 1 cntr_tx_dropped_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_dropped_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_tx_badlt STATS_COUNT "TX Frames with bad length/type field"
					widget_textBox 1 cntr_tx_badlt_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_badlt_d STATS_COUNT 0 "0" 7 120
					
		#widget_groupHeight 1 kr4_dummygroup PKT_STATS_COUNT 1 "" 350
			
			widget_group 1  KR4 allstatus 1 "PMA"
			
				widget_button 1 read_kr4_status KR4 "Read PMA Status" proc_read_kr4_status
				
				
				
				#
				# Link Training Parameters
				#
				if {$ip_sub_variant_option == "100g_nrz"} {
				widget_group 1  LT KR4 5 "PMA"
				} else {
				widget_group 1  LT KR4 3 "PMA"
				}
										
					
					#widget_button 1 trigger_adapt_button LT "Stop Adaptation"  proc_trigger_adapt
					widget_checkBox 1  htile_prod LT "H-Tile Production Device" proc_htile_prod_enable
					set	htile_prod_enabled 0
					widget_label 1  lt_init LT ""
					widget_label 1  lt_init LT ""
					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_label 1  lt_init LT ""
					widget_label 1  lt_init LT ""
					}
					
					widget_label 1  lt_blank LT ""
					widget_label 1  lt_l0 LT "Lane 0"
					widget_label 1  lt_l1 LT "Lane 1"
					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_label 1  lt_l2 LT "Lane 2"
					widget_label 1  lt_l3 LT "Lane 3"
					}
					
					widget_label 1  conv_tx_title LT "Converged TX (vod, post, pre)"
					widget_label 1  conv_tx_l0 LT "0, 0, 0"
					widget_label 1  conv_tx_l1 LT "0, 0, 0"
					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_label 1  conv_tx_l2 LT "0, 0, 0"
					widget_label 1  conv_tx_l3 LT "0, 0, 0"
					}
					
					widget_label 1  conv_vga_title LT "Converged VGA"
					widget_label 1  conv_vga_l0 LT "0"
					widget_label 1  conv_vga_l1 LT "0"
					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_label 1  conv_vga_l2 LT "0"
					widget_label 1  conv_vga_l3 LT "0"
					}
					
					widget_label 1  conv_ctledc_title LT "Converged CTLE DC"
					widget_label 1  conv_ctledc_l0 LT "0"
					widget_label 1  conv_ctledc_l1 LT "0"
					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_label 1  conv_ctledc_l2 LT "0"
					widget_label 1  conv_ctledc_l3 LT "0"
					}
					
					widget_label 1  conv_ctleac_title LT "Converged CTLE AC"
					widget_label 1  conv_ctleac_l0 LT "0"
					widget_label 1  conv_ctleac_l1 LT "0"
					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_label 1  conv_ctleac_l2 LT "0"
					widget_label 1  conv_ctleac_l3 LT "0"
					}

					widget_label 1  conv_dfe_title LT "Converged DFE"
					widget_labelwidth 1  conv_dfe_l0 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
					widget_labelwidth 1  conv_dfe_l1 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
					if {$ip_sub_variant_option == "100g_nrz"} {
					widget_labelwidth 1  conv_dfe_l2 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
					widget_labelwidth 1  conv_dfe_l3 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
					}	
			
				
			if {$anlt_enabled == 1} {
			
				widget_group 1  kr4_dummy_1 KR4 3 ""
				#
				#Sequencer
				#
				widget_group 1  SEQ kr4_dummy_1 3 "Sequencer"
					
					widget_button 1 reset_seq SEQ "Reset Sequencer"  proc_reset_seq
					widget_label 1   seq_blank_1 SEQ ""
					widget_label 1   seq_blank_2 SEQ ""
		
					widget_label 1   seq_force SEQ "SEQ Force Mode"
					widget_comboBox 1  seq_force_mode SEQ {"No Force" "50GBASE-R2" "100GBASE-R4"}
					widget_button 1 seq_force SEQ "Force" proc_seq_force
					
					widget_label 1  SEQ_LNK_RDY SEQ "SEQ Link Ready"
					widget_led 1 SEQ_LNK_RDY_LED SEQ ""  black
					widget_label 1   seq_blank_3 SEQ ""
		
					widget_label 1  SEQ_MODE SEQ "SEQ Mode"
					widget_textBox 1  SEQ_RECONFG_MODE SEQ 0 "---" 7 125
					widget_label 1   seq_blank_3 SEQ ""
		
				#
				# Auto Negotiation & FEC Parameters
				#
				widget_group 1  AN_FEC kr4_dummy_1 7 "Auto Negotiation"
				
				
				
					widget_group 1  AN AN_FEC 2 "AN"
					
						widget_checkBox 1 ignore_tx_nonce AN "Ignore Nonce Field" proc_ignore_nonce
						widget_label 1  ignore_tx_nonce_dummy AN ""
							
						widget_label 1  an_ena_title AN "AN Enable"
						widget_led 1 an_ena_data AN ""  black
						
						widget_label 1  an_comp_title AN "AN Complete"
						widget_textBox 1  an_comp_data AN 0 "---" 7 125
						
						widget_label 1  an_abi_title AN "AN Ability"
						widget_textBox 1  an_abi_data AN 0 "---" 7 125
						
						widget_label 1  an_stat_title AN "AN Status"
						widget_led 1	an_stat_data AN ""  black
						
						widget_label 1  seq_an_title AN "SEQ AN"
						widget_textBox 1  seq_an_data AN 0 "---" 7 125
						
						widget_label 1  fi_an_title AN "Final AN Tech"
						widget_textBox 1 	fi_an_data AN 0 "---" 7 125
					
				widget_group 1  LT kr4_dummy_1 2 "LT"
					
					widget_label 1  lt_ena_title LT "LT Enable"
					widget_led 1 lt_ena_data LT ""  black
					

			}	
					
			if {$anlt_enabled} {
				widget_groupHeight 1 kr4_dummygroup KR4 1 "" 970				
				} else {
				widget_groupHeight 1 kr4_dummygroup KR4 1 "" 1200				
				}
		
	
		help_tab
							
	
	
}

proc help_tab {} {

	global dash

	widget_group 1  Help allstatus 1 "Help"	

		widget_group 1 instructions Help 1 "Link Bring Up Guidelines"
		
				widget_label 1 kr_steps instructions "if (KR is enabled) ("					
				dashboard_set_property $dash kr_steps foregroundColor blue			
				widget_label 1 instructions_2 instructions	"      if (Internal Serial Loop-back or External Loop-back) ("
					dashboard_set_property $dash instructions_2 foregroundColor blue			
				widget_label 1 select_ip_note instructions	"            1. Check Ignore Nonce check box in PMA tab"
					#dashboard_set_property $dash select_ip_note foregroundColor blue
				widget_label 1 instructions_1 instructions	"            2. Click Reset sequencer button in PMA tab"
					#dashboard_set_property $dash instructions_1 foregroundColor blue
				widget_label 1 instructions_2a instructions	"            if ( Internal Serial Loop-back) ("
					dashboard_set_property $dash instructions_2a foregroundColor blue
				widget_label 1 instructions_2 instructions	"                  3. Click on Enable Serial PMA Loop-back button in MAC & PCS tab"				
				widget_label 1 instructions_2b instructions	"            )"
					dashboard_set_property $dash instructions_2b foregroundColor blue
				widget_label 1 instructions_2 instructions	"            4. Click on Continuous Read All registers or Read PCS Status. The link should be up"
					#dashboard_set_property $dash instructions_2 foregroundColor blue	
				widget_label 1 instructions_Mis_Kr instructions	"      ) elseif (Connect to Link Partner) ("
					dashboard_set_property $dash instructions_Mis_Kr foregroundColor blue
				widget_label 1 instructions_2 instructions	"            1. Click on Continuous Read All registers or Read PCS Status"
				widget_label 1 instructions_3 instructions	"      )"
					dashboard_set_property $dash instructions_3 foregroundColor blue
				widget_label 1 instructions_3 instructions	")"
					dashboard_set_property $dash instructions_3 foregroundColor blue
				
				
		widget_groupHeight 1 help_status_dummygroup Help 1 "" 1200
		
}	

proc proc_continuous_read {} {
	global dash
	global MAIN_DICT_s10_100g_0
	global anlt_enabled
	
	freeze_buttons
		while {[string match [dashboard_get_property $dash continuous_read checked] "true"]} {
		proc_read_txmac_status_htile_hip
		proc_read_rxmac_status_htile_hip
		proc_read_pcs_status
		proc_read_tx_stats
		proc_read_rx_stats
		proc_read_kr4_status
		
		}
	unfreeze_buttons	
}

proc freeze_buttons {} {
	
	global dash
	global anlt_enabled
	global freeze1
	global freeze2
	global freeze3
	global freeze4
	global freeze5
	global freeze6
	global freeze7
	
	global textbox_freeze1
	global textbox_freeze2
	global textbox_freeze3
	global textbox_freeze4
	global textbox_freeze5
	global textbox_freeze6
	global textbox_freeze7
	
	dashboard_set_property $dash launch enabled false
	dashboard_set_property $dash list_jtag enabled false
	dashboard_set_property $dash set_jtag enabled false	
	
	dashboard_set_property $dash full_sys_rst enabled false	
	dashboard_set_property $dash soft_txp_rst enabled false	
	dashboard_set_property $dash soft_rxp_rst enabled false	
	
	dashboard_set_property $dash read_pcs_status enabled false	
	dashboard_set_property $dash eio_sloop enabled false	
	
	dashboard_set_property $dash read_txmac_status_htile_hip enabled false	
	dashboard_set_property $dash read_rxmac_status_htile_hip enabled false	
	
	dashboard_set_property $dash read_tx_stats enabled false	
	dashboard_set_property $dash read_rx_stats enabled false	
	dashboard_set_property $dash reset_tx_stats enabled false	
	dashboard_set_property $dash reset_rx_stats enabled false	
	
	dashboard_set_property $dash read_kr4_status enabled false
	dashboard_set_property $dash htile_prod enabled false
	#dashboard_set_property $dash trigger_adapt_button enabled false
	
	if {$anlt_enabled == 1} {
		
		dashboard_set_property $dash reset_seq enabled false
		dashboard_set_property $dash seq_force enabled false
	}	
	
	set freeze1 [dashboard_get_property $dash pkt_gen_random_gap enabled]
	set freeze2 [dashboard_get_property $dash pkt_gen_no_gap enabled]
	set freeze3 [dashboard_get_property $dash pkt_gen_fixed enabled]
	set freeze4 [dashboard_get_property $dash pkt_gen_incr enabled]
	set freeze5 [dashboard_get_property $dash set_source_add enabled]
	set freeze6 [dashboard_get_property $dash set_dest_add enabled]
	set freeze7 [dashboard_get_property $dash mac_loopback enabled]
	
	set textbox_freeze1 [dashboard_get_property $dash source_Add editable]
	set textbox_freeze2 [dashboard_get_property $dash dest_Add editable]
	set textbox_freeze3 [dashboard_get_property $dash pkt_byte_size_val editable]
	set textbox_freeze4 [dashboard_get_property $dash pkt_num_val editable]
	set textbox_freeze5 [dashboard_get_property $dash pkt_byte_size_begin_val editable]
	set textbox_freeze6 [dashboard_get_property $dash pkt_byte_size_end_val editable]
	set textbox_freeze7 [dashboard_get_property $dash pkt_incr_num_val editable]
	
	
	dashboard_set_property $dash pkt_gen_random_gap enabled false	
	dashboard_set_property $dash pkt_gen_no_gap enabled false	
	dashboard_set_property $dash pkt_gen_fixed enabled false	
	dashboard_set_property $dash pkt_gen_incr enabled false		
	dashboard_set_property $dash set_source_add enabled false		
	dashboard_set_property $dash set_dest_add enabled false		
	dashboard_set_property $dash mac_loopback enabled false		
	dashboard_set_property $dash pkt_cntrl_en enabled false		
	
	
	if { [string match [dashboard_get_property $dash pkt_cntrl_en checked] "true"] & [string match [dashboard_get_property $dash mac_loopback checked] "false"] } {
	dashboard_set_property $dash source_Add editable 0
	dashboard_set_property $dash dest_Add editable 0
	dashboard_set_property $dash pkt_byte_size_val editable 0
	dashboard_set_property $dash pkt_num_val editable 0
	dashboard_set_property $dash pkt_byte_size_begin_val editable 0
	dashboard_set_property $dash pkt_byte_size_end_val editable 0
	dashboard_set_property $dash pkt_incr_num_val editable 0
	}
}

proc unfreeze_buttons {} {

	global dash
	global anlt_enabled
	global freeze1
	global freeze2
	global freeze3
	global freeze4
	global freeze5
	global freeze6
	global freeze7
	
	global textbox_freeze1
	global textbox_freeze2
	global textbox_freeze3
	global textbox_freeze4
	global textbox_freeze5
	global textbox_freeze6
	global textbox_freeze7
		
	dashboard_set_property $dash launch enabled true
	dashboard_set_property $dash list_jtag enabled true
	dashboard_set_property $dash set_jtag enabled true	
	
	dashboard_set_property $dash full_sys_rst enabled true	
	dashboard_set_property $dash soft_txp_rst enabled true	
	dashboard_set_property $dash soft_rxp_rst enabled true	
	
	dashboard_set_property $dash read_pcs_status enabled true	
	dashboard_set_property $dash eio_sloop enabled true	
	
	dashboard_set_property $dash read_txmac_status_htile_hip enabled true	
	dashboard_set_property $dash read_rxmac_status_htile_hip enabled true	
	
	dashboard_set_property $dash read_tx_stats enabled true	
	dashboard_set_property $dash read_rx_stats enabled true	
	dashboard_set_property $dash reset_tx_stats enabled true	
	dashboard_set_property $dash reset_rx_stats enabled true	
	
	dashboard_set_property $dash read_kr4_status enabled true
	dashboard_set_property $dash htile_prod enabled true
	#dashboard_set_property $dash trigger_adapt_button enabled true
	
	if {$anlt_enabled == 1} {
		
		dashboard_set_property $dash reset_seq enabled true
		dashboard_set_property $dash seq_force enabled true
	}
	
	
	dashboard_set_property $dash pkt_gen_random_gap enabled $freeze1 
	dashboard_set_property $dash pkt_gen_no_gap enabled $freeze2
	dashboard_set_property $dash pkt_gen_fixed enabled $freeze3 
	dashboard_set_property $dash pkt_gen_incr enabled $freeze4
	dashboard_set_property $dash set_source_add enabled $freeze5
	dashboard_set_property $dash set_dest_add enabled $freeze6
	dashboard_set_property $dash mac_loopback enabled $freeze7
	
	dashboard_set_property $dash pkt_cntrl_en enabled true
	
	if { [string match [dashboard_get_property $dash pkt_cntrl_en checked] "true"] & [string match [dashboard_get_property $dash mac_loopback checked] "false"] } {
	dashboard_set_property $dash source_Add editable $textbox_freeze1
	dashboard_set_property $dash dest_Add editable $textbox_freeze2
	dashboard_set_property $dash pkt_byte_size_val editable $textbox_freeze3
	dashboard_set_property $dash pkt_num_val editable $textbox_freeze4
	dashboard_set_property $dash pkt_byte_size_begin_val editable $textbox_freeze5
	dashboard_set_property $dash pkt_byte_size_end_val editable $textbox_freeze6
	dashboard_set_property $dash pkt_incr_num_val editable $textbox_freeze7
	
	}
	
}

proc proc_full_sys_rst {} {

	global dash
	
	global MAIN_DICT_s10_100g_0
	
	if {[string match [dashboard_get_property $dash full_sys_rst text] "Assert Full System Reset"]} {
	reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMACFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x1
	dashboard_set_property $dash full_sys_rst text "Deassert Full System Reset"
	} elseif {[string match [dashboard_get_property $dash full_sys_rst text] "Deassert Full System Reset"]} {
	reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMACFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x0
	dashboard_set_property $dash full_sys_rst text "Assert Full System Reset"
	}
	after 10
}

proc proc_soft_txp_rst {} {
	global dash
	
	global MAIN_DICT_s10_100g_0
	
	if {[string match [dashboard_get_property $dash soft_txp_rst text] "Assert TX MAC & PCS Reset"]} {
	reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMACFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x2
	dashboard_set_property $dash soft_txp_rst text "Deassert TX MAC & PCS Reset"
	} elseif {[string match [dashboard_get_property $dash soft_txp_rst text] "Deassert TX MAC & PCS Reset"]} {
	reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMACFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x0
	dashboard_set_property $dash soft_txp_rst text "Assert TX MAC & PCS Reset"
	}
	after 10
}

proc proc_soft_rxp_rst {} {
	global dash
	
	global MAIN_DICT_s10_100g_0
	
	if {[string match [dashboard_get_property $dash soft_rxp_rst text] "Assert RX MAC & PCS Reset"]} {
	reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMACFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x4
	dashboard_set_property $dash soft_rxp_rst text "Deassert RX MAC & PCS Reset"
	} elseif {[string match [dashboard_get_property $dash soft_rxp_rst text] "Deassert RX MAC & PCS Reset"]} {
	reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMACFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x0
	dashboard_set_property $dash soft_rxp_rst text "Assert RX MAC & PCS Reset"
	}
	after 10
}

proc proc_read_txmac_status_htile_hip {} {

	global dash
	global BASE_HTILE_HIP

	#puts "Reading TX MAC Configuration"

	set txmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x405]
		if {[expr $txmac_value_htile_hip & 0x00000008]} {
			dashboard_set_property $dash force_remote_fault_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash force_remote_fault_text_htile_hip text "Off"
           }
		if {[expr $txmac_value_htile_hip & 0x00000004]} {
			dashboard_set_property $dash disable_remote_fault_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash disable_remote_fault_text_htile_hip text "Off"
           }
		if {[expr $txmac_value_htile_hip & 0x00000002]} {
			dashboard_set_property $dash unidir_remote_link_fault_reporting_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash unidir_remote_link_fault_reporting_text_htile_hip text "Off"
           }
		if {[expr $txmac_value_htile_hip & 0x00000001]} {
			dashboard_set_property $dash link_fault_reporting_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash link_fault_reporting_text_htile_hip text "Off"
           }
		   
	set txmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x406]
		dashboard_set_property $dash idle_col_rem_text_htile_hip text "$txmac_value_htile_hip"
	
	set txmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x407]
		dashboard_set_property $dash max_tx_size_config_text_htile_hip text "$txmac_value_htile_hip"
	
	set txmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x40A]
		if {[expr $txmac_value_htile_hip & 0x00000004]} {
			dashboard_set_property $dash en_saddr_insert_text_htile_hip text "TX MAC inserts source address"
			} else {
			dashboard_set_property $dash en_saddr_insert_text_htile_hip text "Client provides Source Address"
           }
		   
	set txmac_value_htile_hip [reg_read 0x040D]
	dashboard_set_property $dash saddrh_text_htile_hip text "$txmac_value_htile_hip"

	set txmac_value_htile_hip [reg_read 0x040C]
	dashboard_set_property $dash saddrl_text_htile_hip text "$txmac_value_htile_hip"
	
	set txmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x40A]
		if {[expr $txmac_value_htile_hip & 0x00000001]} {
			dashboard_set_property $dash vlan_detection_tx_text_htile_hip text "Disabled"
			} else {
			dashboard_set_property $dash vlan_detection_tx_text_htile_hip text "Enabled"
           }
		   
	set txmac_value_htile_hip [reg_read 0x040B]
		if {[expr $txmac_value_htile_hip & 0x00000200]} {
			dashboard_set_property $dash txcrc_covers_preamble_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash txcrc_covers_preamble_text_htile_hip text "Off"
           }
		if {[expr $txmac_value_htile_hip & 0x00000006]} {
			dashboard_set_property $dash ipg_text_htile_hip text "1 byte"
			} elseif {[expr $txmac_value_htile_hip & 0x00000004]} {
			dashboard_set_property $dash ipg_text_htile_hip text "4 bytes"
           } elseif {[expr $txmac_value_htile_hip & 0x00000002]} {
			dashboard_set_property $dash ipg_text_htile_hip text "8 bytes"
           } else {
		    dashboard_set_property $dash ipg_text_htile_hip text "12 bytes"
		   }
		if {[expr $txmac_value_htile_hip & 0x00000001]} {
			dashboard_set_property $dash en_pp_tx_text_htile_hip text "Enabled"
			} else {
			dashboard_set_property $dash en_pp_tx_text_htile_hip text "Disabled"
           }
		   
}
		
			
				   


proc proc_read_rxmac_status_htile_hip {} {

	global dash
	global BASE_HTILE_HIP

	#puts "Reading RX MAC Configuration"

	set rxmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x506]
		dashboard_set_property $dash max_rx_size_config_text_htile_hip text "$rxmac_value_htile_hip"
		
	set rxmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x507]
		if {[expr $rxmac_value_htile_hip & 0x00000001]} {
			dashboard_set_property $dash mac_crc_config_text_htile_hip text "Forward CRC to RX Client"
			} else {
			dashboard_set_property $dash mac_crc_config_text_htile_hip text "Remove CRC from RX frames"
           }
		   
	set rxmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x508]
		if {[expr $rxmac_value_htile_hip & 0x00000002]} {
			dashboard_set_property $dash remote_fault_text_htile_hip text "Yes"
				dashboard_set_property $dash remote_fault_htile_hip foregroundColor red
			} else {
			dashboard_set_property $dash remote_fault_text_htile_hip text "No"
				dashboard_set_property $dash remote_fault_htile_hip foregroundColor black
           }
		if {[expr $rxmac_value_htile_hip & 0x00000001]} {
			dashboard_set_property $dash local_fault_text_htile_hip text "Yes"
				dashboard_set_property $dash local_fault_htile_hip foregroundColor red
			} else {
			dashboard_set_property $dash local_fault_text_htile_hip text "No"
				dashboard_set_property $dash local_fault_htile_hip foregroundColor black
           }
		   
	set rxmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x50A]
		if {[expr $rxmac_value_htile_hip & 0x00000100]} {
			dashboard_set_property $dash remove_rx_pad_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash remove_rx_pad_text_htile_hip text "Off"
           }
		if {[expr $rxmac_value_htile_hip & 0x00000080]} {
			dashboard_set_property $dash enforce_max_rx_text_htile_hip text "Frames are ended with FCS error"
			} else {
			dashboard_set_property $dash enforce_max_rx_text_htile_hip text "Ovesized frames are not altered"
           }
		if {[expr $rxmac_value_htile_hip & 0x00000010]} {
			dashboard_set_property $dash preamble_check_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash preamble_check_text_htile_hip text "Off"
           }
		if {[expr $rxmac_value_htile_hip & 0x00000008]} {
			dashboard_set_property $dash sfd_check_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash sfd_check_text_htile_hip text "Off"
           }
		if {[expr $rxmac_value_htile_hip & 0x00000002]} {
			dashboard_set_property $dash vlan_detection_rx_text_htile_hip text "Disabled"
			} else {
			dashboard_set_property $dash vlan_detection_rx_text_htile_hip text "Enabled"
           }
		if {[expr $rxmac_value_htile_hip & 0x00000001]} {
			dashboard_set_property $dash en_plen_text_htile_hip text "On"
			} else {
			dashboard_set_property $dash en_plen_text_htile_hip text "Off"
           }
		   
	set rxmac_value_htile_hip [reg_read $BASE_HTILE_HIP 0x50B]
		if {[expr $rxmac_value_htile_hip & 0x00000002]} {
			dashboard_set_property $dash rxcrc_covers_preamble_text_htile_hip text "RX CRC calculated over frame plus preamble"
			} else {
			dashboard_set_property $dash rxcrc_covers_preamble_text_htile_hip text "RX CRC calculated over Ethernet Frame"
           }
		if {[expr $rxmac_value_htile_hip & 0x00000001]} {
			dashboard_set_property $dash en_pp_rx_text_htile_hip text "Enabled"
			} else {
			dashboard_set_property $dash en_pp_rx_text_htile_hip text "Disabled"
           }
	
}

proc ignore_nonce_check {} {
	
	global dash
	
		if { [dashboard_get_property $dash ignore_nonce checked] } {
		
			ignore_nonce_en
			
		} else {
			
			ignore_nonce_dis
		}
		

}
proc ignore_nonce_dis {} {
  global BASE_HTILE_HIP
  
  set an_c0 [reg_read    $BASE_HTILE_HIP 0x00C0]
  set an_c0 [expr $an_c0 & 0x7F]
  reg_write   $BASE_HTILE_HIP 0x00C0 $an_c0
}

proc ignore_nonce_en {} {
  global BASE_HTILE_HIP
  
  set an_c0 [reg_read    $BASE_HTILE_HIP 0x00C0]
  set an_c0 [expr $an_c0 | 0x80]
  reg_write   $BASE_HTILE_HIP 0x00C0 $an_c0
}

proc proc_ignore_nonce {} {
	
	global dash
	global BASE_HTILE_HIP
	
	if {[dashboard_get_property $dash ignore_tx_nonce checked]} {
		ignore_nonce_en
		
	} else {
		ignore_nonce_dis
	}	
	
	
}
proc kr_restart {} {
  global BASE_HTILE_HIP
  
  set reg [reg_read   $BASE_HTILE_HIP 0x00B0]
  reg_write $BASE_HTILE_HIP 0x00B0 [expr $reg | 0x7]
}

proc proc_eio_sloop {} {
	global dash
	global anlt_enabled
	global MAIN_DICT_s10_100g_0
	
	if {[string match [dashboard_get_property $dash eio_sloop text] "Enable Serial PMA Loopback"]} {
		reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMALOOP] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0xf
		# if {$anlt_enabled} {
			# #ignore_nonce_en
			# #kr_restart
		# }
		after 300
		dashboard_set_property $dash eio_sloop text "Disable Serial PMA Loopback"
		proc_read_pcs_status
		if {$anlt_enabled} {
			proc_read_kr4_status
		}
	} elseif {[string match [dashboard_get_property $dash eio_sloop text] "Disable Serial PMA Loopback"]} {
		reg_write [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PMALOOP] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x0
		# if {$anlt_enabled} {
			# #ignore_nonce_dis
			# #kr_restart
		# }
		
		after 300
		dashboard_set_property $dash eio_sloop text "Enable Serial PMA Loopback"
		proc_read_pcs_status
		if {$anlt_enabled} {
			proc_read_kr4_status
		}
	}
		
}

proc proc_read_pcs_status {} {
	global dash
	
	global MAIN_DICT_s10_100g_0
	
	proc_read_pcs_status_1
	after 50
	proc_read_pcs_status_1
}

proc proc_read_pcs_status_1 {} {
	global dash
	
	global MAIN_DICT_s10_100g_0
	global ip_sub_variant_option
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_FREQLOCK] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x321 RX CDR PLL Locked $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash rxcdrplllocked_l0 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l0 color red
           }
	    if {[expr $pcs_status_value & 0x00000002]} {
             dashboard_set_property $dash rxcdrplllocked_l1 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l1 color red
           }
		if {$ip_sub_variant_option == "100g_nrz"} {   
	    if {[expr $pcs_status_value & 0x00000004]} {
             dashboard_set_property $dash rxcdrplllocked_l2 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l2 color red
           }
	    if {[expr $pcs_status_value & 0x00000008]} {
             dashboard_set_property $dash rxcdrplllocked_l3 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l3 color red
           }
		}   
		   
		
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_PHYCLK] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x322 PHY CLK $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash txpcsready_stat color green
           } else {
             dashboard_set_property $dash txpcsready_stat color red
           }
    	   
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_FRMERROR] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x323 Frame Error $pcs_status_value"
	dashboard_set_property $dash frameerror_stat text "$pcs_status_value"
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_FALIGNED] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x326 RX PCS Fully Aligned $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash rxpcs_stat color green
           } else {
             dashboard_set_property $dash rxpcs_stat color red
           }
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_AMLOCK] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x328 Alignment Marker $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash amlock_stat color green
           } else {
             dashboard_set_property $dash amlock_stat color red
           }
	 
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_RXCLKHZ] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x341 RX Clock $pcs_status_value"
		dashboard_set_property $dash rxclk_stat text [format %u [expr $pcs_status_value * 10] ] 
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_PHY_TXCLKHZ] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x342 TX Clock $pcs_status_value"
		dashboard_set_property $dash txclk_stat text [format %u [expr $pcs_status_value * 10] ] 
		
	set pcs_status_value [reg_read 0x32A [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	dashboard_set_property $dash bercount_value text "$pcs_status_value"
	
	
	set pcs_status_value [reg_read 0x326 [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	if {[expr $pcs_status_value & 0x00000002]} {
		dashboard_set_property $dash hiber_value text "Detected"
        } else {
        dashboard_set_property $dash hiber_value text "Not Detected"
        }	
	set pcs_status_value [reg_read 0X0320]
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash tx_pma_clock_locked_l0 color green
           } else {
             dashboard_set_property $dash tx_pma_clock_locked_l0 color red
           }
		   
		
	    if {[expr $pcs_status_value & 0x00000002]} {
             dashboard_set_property $dash tx_pma_clock_locked_l1 color green
           } else {
             dashboard_set_property $dash tx_pma_clock_locked_l1 color red
           }
		   
	    if {$ip_sub_variant_option == "100g_nrz"} {  
		if {[expr $pcs_status_value & 0x00000004]} {
             dashboard_set_property $dash tx_pma_clock_locked_l2 color green
           } else {
             dashboard_set_property $dash tx_pma_clock_locked_l2 color red
           }
		}   
		if {$ip_sub_variant_option == "100g_nrz"} {     
	    if {[expr $pcs_status_value & 0x00000008]} {
             dashboard_set_property $dash tx_pma_clock_locked_l3 color green
           } else {
             dashboard_set_property $dash tx_pma_clock_locked_l3 color red
           }
		}
	
}


proc proc_pkt_gen_random_gap {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_random_gap text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_random_gap text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		#dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		reg_write 0x1010 0x5
	} elseif {[string match [dashboard_get_property $dash pkt_gen_random_gap text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_random_gap text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		#dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x7
	}

}

proc proc_pkt_gen_no_gap {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_no_gap text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_no_gap text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		#dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		reg_write 0x1010 0x85
	} elseif {[string match [dashboard_get_property $dash pkt_gen_no_gap text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_no_gap text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		#dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x87
	}

}

proc proc_pkt_gen_fixed {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_fixed text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_fixed text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		#dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		set size [dashboard_get_property $dash pkt_byte_size_val text]
		set hex_size 0x[format %x $size]
		reg_write 0x1008 $hex_size
		set num [dashboard_get_property $dash pkt_num_val text]
		set hex_num 0x[format %x $num]
		reg_write 0x1009 $hex_num
		reg_write 0x1010 0x55
	} elseif {[string match [dashboard_get_property $dash pkt_gen_fixed text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_fixed text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		#dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x57
	}

}

proc proc_pkt_gen_incr {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_incr text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_incr text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		#dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		set begin_size [dashboard_get_property $dash pkt_byte_size_begin_val text]
		set begin_size_hex 0x[format %x $begin_size]
	
		set end_size [dashboard_get_property $dash pkt_byte_size_end_val text]
		set end_size_hex 0x[format %x $end_size]
		
		#reg_write 0x1008 $size
		set end_size_shift [ expr $end_size_hex << 16 ]
		set size [ expr $end_size_shift + $begin_size_hex ]
		reg_write 0x1008 $size
		set num [dashboard_get_property $dash pkt_incr_num_val text]
		set num_hex 0x[format %x $num]
		reg_write 0x1009 $num_hex
		reg_write 0x1010 0x65
	} elseif {[string match [dashboard_get_property $dash pkt_gen_incr text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_incr text "Start Packet Generator"
		dashboard_set_property $dash pkt_gen_fixed text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		#dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x67
	}

}


proc proc_read_tx_stats {} {
	global dash
global BASE_HTILE_HIP

#puts "Reading TX MAC Statistics Counters"

	#Pausing - TX Shadow Request
	reg_write $BASE_HTILE_HIP 0x845 0x4
	
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x800]
		dashboard_set_property $dash cntr_tx_fragments_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x802]
		dashboard_set_property $dash cntr_tx_jabbers_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x804]
		dashboard_set_property $dash cntr_tx_fcs_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x806]
		dashboard_set_property $dash cntr_tx_fcs_err_okpkt_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x808]
		dashboard_set_property $dash cntr_tx_mcast_data_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x80A]
		dashboard_set_property $dash cntr_tx_bcast_data_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x80C]
		dashboard_set_property $dash cntr_tx_ucast_data_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x80E]
		dashboard_set_property $dash cntr_tx_mcast_ctrl_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x801]
		dashboard_set_property $dash cntr_tx_bcast_ctrl_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x812]
		dashboard_set_property $dash cntr_tx_ucast_ctrl_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x814]
		dashboard_set_property $dash cntr_tx_pause_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x816]
		dashboard_set_property $dash cntr_tx_64b_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x818]
		dashboard_set_property $dash cntr_tx_65to127b_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x81A]
		dashboard_set_property $dash cntr_tx_128to255b_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x81C]
		dashboard_set_property $dash cntr_tx_256to511b_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x81E]
		dashboard_set_property $dash cntr_tx_512to1023b_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x820]
		dashboard_set_property $dash cntr_tx_1024to1518b_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x822]
		dashboard_set_property $dash cntr_tx_1519tomaxb_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x824]
		dashboard_set_property $dash cntr_tx_oversize_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x826]
		dashboard_set_property $dash cntr_tx_mcast_data_ok_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x828]
		dashboard_set_property $dash cntr_tx_bcast_data_ok_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x82A]
		dashboard_set_property $dash cntr_tx_ucast_data_ok_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x82C]
		dashboard_set_property $dash cntr_tx_mcast_ctrl_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x82E]
		dashboard_set_property $dash cntr_tx_bcast_ctrl_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x830]
		dashboard_set_property $dash cntr_tx_ucast_ctrl_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x832]
		dashboard_set_property $dash cntr_tx_pause_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x834]
		dashboard_set_property $dash cntr_tx_runt_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x836]
		dashboard_set_property $dash cntr_tx_st_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x838]
		dashboard_set_property $dash cntr_tx_lenerr_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x83A]
		dashboard_set_property $dash cntr_tx_pfc_err_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x83C]
		dashboard_set_property $dash cntr_tx_pfc_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x860]
		dashboard_set_property $dash cntr_tx_payloadoctetsok_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x862]
		dashboard_set_property $dash txoctetsok_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x864]
		dashboard_set_property $dash cntr_tx_malformed_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x866]
		dashboard_set_property $dash cntr_tx_dropped_d text "$tx_count_htile_hip"
		
	set tx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x868]
		dashboard_set_property $dash cntr_tx_badlt_d text "$tx_count_htile_hip"
		
	#Un-Pausing - TX Shadow Request
	reg_write $BASE_HTILE_HIP 0x845 0x0
	
}

proc proc_read_rx_stats {} {
	global dash
global BASE_HTILE_HIP

#puts "Reading RX MAC Statistics Counters"

	#Pausing - TX Shadow Request
	reg_write $BASE_HTILE_HIP 0x945 0x4
	
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x900]
		dashboard_set_property $dash cntr_rx_fragments_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x902]
		dashboard_set_property $dash cntr_rx_jabbers_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x904]
		dashboard_set_property $dash cntr_rx_fcs_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x906]
		dashboard_set_property $dash cntr_rx_fcs_err_okpkt_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x908]
		dashboard_set_property $dash cntr_rx_mcast_data_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x90A]
		dashboard_set_property $dash cntr_rx_bcast_data_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x90C]
		dashboard_set_property $dash cntr_rx_ucast_data_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x90E]
		dashboard_set_property $dash cntr_rx_mcast_ctrl_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x901]
		dashboard_set_property $dash cntr_rx_bcast_ctrl_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x912]
		dashboard_set_property $dash cntr_rx_ucast_ctrl_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x914]
		dashboard_set_property $dash cntr_rx_pause_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x916]
		dashboard_set_property $dash cntr_rx_64b_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x918]
		dashboard_set_property $dash cntr_rx_65to127b_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x91A]
		dashboard_set_property $dash cntr_rx_128to255b_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x91C]
		dashboard_set_property $dash cntr_rx_256to511b_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x91E]
		dashboard_set_property $dash cntr_rx_512to1023b_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x920]
		dashboard_set_property $dash cntr_rx_1024to1518b_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x922]
		dashboard_set_property $dash cntr_rx_1519tomaxb_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x924]
		dashboard_set_property $dash cntr_rx_oversize_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x926]
		dashboard_set_property $dash cntr_rx_mcast_data_ok_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x928]
		dashboard_set_property $dash cntr_rx_bcast_data_ok_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x92A]
		dashboard_set_property $dash cntr_rx_ucast_data_ok_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x92C]
		dashboard_set_property $dash cntr_rx_mcast_ctrl_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x92E]
		dashboard_set_property $dash cntr_rx_bcast_ctrl_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x930]
		dashboard_set_property $dash cntr_rx_ucast_ctrl_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x932]
		dashboard_set_property $dash cntr_rx_pause_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x934]
		dashboard_set_property $dash cntr_rx_runt_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x936]
		dashboard_set_property $dash cntr_rx_st_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x938]
		dashboard_set_property $dash cntr_rx_lenerr_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x93A]
		dashboard_set_property $dash cntr_rx_pfc_err_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x93C]
		dashboard_set_property $dash cntr_rx_pfc_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x960]
		dashboard_set_property $dash cntr_rx_payloadoctetsok_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x962]
		dashboard_set_property $dash rxoctetsok_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x964]
		dashboard_set_property $dash cntr_rx_malformed_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x966]
		dashboard_set_property $dash cntr_rx_dropped_d text "$rx_count_htile_hip"
		
	set rx_count_htile_hip [stats_read $BASE_HTILE_HIP 0x968]
		dashboard_set_property $dash cntr_rx_badlt_d text "$rx_count_htile_hip"
		
	#Un-Pausing - TX Shadow Request
	reg_write $BASE_HTILE_HIP 0x945 0x0
		
}


proc proc_pause_tx_stats {} {
	global dash
	
	global MAIN_DICT_s10_100g_0
	
	if {[string match [dashboard_get_property $dash pause_tx_stats text] "Pause TX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_100g_0 TX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x4
		dashboard_set_property $dash pause_tx_stats text "Unpause TX Statistics Counters Collection"
		dashboard_set_property $dash tx_stats_pause_d text "paused"
	} elseif {[string match [dashboard_get_property $dash pause_tx_stats text] "Unpause TX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_100g_0 TX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x0
		dashboard_set_property $dash pause_tx_stats text "Pause TX Statistics Counters Collection"
		dashboard_set_property $dash tx_stats_pause_d text "unpaused"
	}	
}


proc proc_pause_rx_stats {} {
	global dash
	
	global MAIN_DICT_s10_100g_0
	
	if {[string match [dashboard_get_property $dash pause_rx_stats text] "Pause RX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_100g_0 RX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x4
		dashboard_set_property $dash pause_rx_stats text "Unpause RX Statistics Counters Collection"
		dashboard_set_property $dash rx_stats_pause_d text "paused"
	} elseif {[string match [dashboard_get_property $dash pause_rx_stats text] "Unpause RX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_100g_0 RX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x0
		dashboard_set_property $dash pause_rx_stats text "Pause RX Statistics Counters Collection"
		dashboard_set_property $dash rx_stats_pause_d text "unpaused"
	}	
}

proc proc_clear_tx_stats_parity {} {
	global dash
	global MAIN_DICT_s10_100g_0
	reg_write  [dict get $MAIN_DICT_s10_100g_0 TX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x2
	dashboard_set_property $dash tx_stats_parity_led color black
}

proc proc_clear_rx_stats_parity {} {
	global dash
	global MAIN_DICT_s10_100g_0
	reg_write  [dict get $MAIN_DICT_s10_100g_0 RX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x2
	dashboard_set_property $dash rx_stats_parity_led color black
}

proc proc_reset_tx_stats {} {
	global dash
	global BASE_HTILE_HIP
	puts "Reseting TX MAC Statistics Counters"
	reg_write $BASE_HTILE_HIP 0x845 0x1
	after 10
	reg_write $BASE_HTILE_HIP 0x845 0x0
	after 10
	proc_read_tx_stats
}

proc proc_reset_rx_stats {} {
	global dash
	global BASE_HTILE_HIP
	puts "Reseting RX MAC Statistics Counters"
	reg_write $BASE_HTILE_HIP 0x945 0x1
	after 10
	reg_write $BASE_HTILE_HIP 0x945 0x0
	after 10
	proc_read_rx_stats
}

proc proc_reset_seq {} {
	global dash
	global MAIN_DICT_s10_100g_0
	
	#reconfig_reg_rmw {chan addr offset mask val}
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x1 0x1

}

proc an_disable {} {
  global BASE_HTILE_HIP
  
  set an_c0 [reg_read    $BASE_HTILE_HIP 0xc0]
  set an_c0 [expr $an_c0 & 0xFE]
  reg_write   $BASE_HTILE_HIP 0xc0 $an_c0
}

proc an_enable {} {
  global BASE_HTILE_HIP
  
  set an_c0 [reg_read    $BASE_HTILE_HIP 0xc0]
  set an_c0 [expr $an_c0 | 0x1]
  reg_write   $BASE_HTILE_HIP 0xc0 $an_c0
}

proc proc_seq_force {} {
	global dash
	global MAIN_DICT_s10_100g_0
	
	if {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "No Force"]} {
	#set val 0x01
	an_enable
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x01 0x01
	} elseif {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "50GBASE-R2"]} {
	#set val 0x41
	an_disable
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x000000f1 0x21
	} elseif {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "100GBASE-R4"]} {
	#set val 0x51
	an_disable
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0x000000f1 0x31
	}

	#reconfig_reg_rmw {chan addr offset mask val}
	#reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR] 0xffffff0e $val

}

proc proc_htile_prod_enable {} {
	
global dash
global htile_prod_enabled 

	if { [dashboard_get_property $dash htile_prod checked] } {
		set htile_prod_enabled 1
		
	} else {
		set htile_prod_enabled 0
		
	}

}

proc proc_read_kr4_status {} {
	global dash
	global MAIN_DICT_s10_100g_0
	
	proc_read_kr4_status_1
	after 50
	proc_read_kr4_status_1

}

proc proc_read_kr4_status_1 {} {
	global dash
	global MAIN_DICT_s10_100g_0
	global anlt_enabled
	
	proc_lt_all_status
	
	if {$anlt_enabled} {
	set DATA_KR_04D0 [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04D0] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x04D0 $DATA_KR_04D0"
	    if {[expr $DATA_KR_04D0 & 0x00000001]} {
             dashboard_set_property $dash lt_ena_data color "green"
           } else {
             dashboard_set_property $dash lt_ena_data color "red"
           }
	
	set DATA_KR_04B1 [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04B1] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x04B1 $DATA_KR_04B1"
	    if {[expr $DATA_KR_04B1 & 0x00000001]} {
             dashboard_set_property $dash SEQ_LNK_RDY_LED color "green"
           } else {
             dashboard_set_property $dash SEQ_LNK_RDY_LED color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00000100]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "AN mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00000200]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "LT mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00001000]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "50G Data Mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00002000]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "100G Data Mode"
           } else {
		   dashboard_set_property $dash SEQ_RECONFG_MODE text "---"
           }
		
		
		   
	set DATA_KR_04C0 [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04C0] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x04C0 $DATA_KR_04C0"
	    if {[expr $DATA_KR_04C0 & 0x00000001]} {
             dashboard_set_property $dash an_ena_data color "green"
           } else {
             dashboard_set_property $dash an_ena_data color "red"
           }
		   
	set DATA_KR_04C2 [reg_read [dict get $MAIN_DICT_s10_100g_0 ADDR_KR_04C2] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10CSR]]
	#puts "0x04C2 $DATA_KR_04C2"
	    if {[expr $DATA_KR_04C2 & 0x00000004]} {
             dashboard_set_property $dash an_comp_data text "Complete"
           } else {
             dashboard_set_property $dash an_comp_data text "In Progress"
           }
		   
		if {[expr $DATA_KR_04C2 & 0x00000020]} {
             dashboard_set_property $dash an_abi_data text "Able to perform AN"
           } else {
             dashboard_set_property $dash an_abi_data text "Unable to perform AN"
           }
		   
	    if {[expr $DATA_KR_04C2 & 0x00000040]} {
             dashboard_set_property $dash an_stat_data color "green"
           } else {
             dashboard_set_property $dash an_stat_data color "red"
           }
		   
		#if {[expr $DATA_KR_04C2 & 0x00000080]} {
        #     dashboard_set_property $dash lp_an_abi_data text "Able to perform AN"
        #   } else {
        #     dashboard_set_property $dash lp_an_abi_data text "Unable to perform AN"
        #   }
		   
		if {[expr $DATA_KR_04C2 & 0x00000200]} {
             dashboard_set_property $dash seq_an_data text "Failure detected"
           } else {
             dashboard_set_property $dash seq_an_data text "Failure not detected"
           }
		   
		if {[expr $DATA_KR_04C2 & 0x00080000]} {
             dashboard_set_property $dash fi_an_data text "100GBASE-KP4"
           } elseif {[expr $DATA_KR_04C2 & 0x00100000]} {
             dashboard_set_property $dash fi_an_data text "100GBASE-KR4"
           } elseif {[expr $DATA_KR_04C2 & 0x00200000]} {
             dashboard_set_property $dash fi_an_data text "100GBASE-CR4"
           } elseif {[expr $DATA_KR_04C2 & 0x02000000]} {
             dashboard_set_property $dash fi_an_data text "50GBASE-KR2"
           } elseif {[expr $DATA_KR_04C2 & 0x04000000]} {
             dashboard_set_property $dash fi_an_data text "50GBASE-CR2"
           } else {
			 dashboard_set_property $dash fi_an_data text "---"
		   }

	}
	
}

proc proc_lt_all_status {} {
	global dash
	global MAIN_DICT_s10_100g_0
	global  ip_sub_variant_option
	
	
	
	proc_lt_status {0}
	proc_lt_status {1}
	if {$ip_sub_variant_option == "100g_nrz"} {
	proc_lt_status {2}
	proc_lt_status {3}
	}
}

proc proc_lt_status {chan} {
	global dash
	global MAIN_DICT_s10_100g_0
	global htile_prod_enabled
	
	#set chan 0
	if {$htile_prod_enabled} {
	reconfig_reg_write $chan 0x542 0x10000 0x0
	}
	
	set vod [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_VOD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] ]
	set vod [expr $vod & 0x1f]
	
	set post [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_POST] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]]
	if {$post & 0x40} {
        set post [expr -($post & 0x1f)]
    } else {
        set post [expr $post & 0x1f]
    }
	
	set pre [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_PRE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]]
    if {$pre & 0x20} {
        set pre [expr -($pre & 0x1f)]
    } else {
        set pre [expr $pre & 0x1f]
    }
	dashboard_set_property $dash conv_tx_l$chan text "$vod, $post, $pre"
	#dashboard_set_property $dash conv_tx_l${chan} text "$vod, $post, $pre"
	
	#  Test bus = ADP 171[4:1]=1
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPBLOCK] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x1E 0x16
    
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 5
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
	set vga [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x1F]
	dashboard_set_property $dash conv_vga_l$chan text "$vga"
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 4
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set ctle_dc [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x3F]
	dashboard_set_property $dash conv_ctledc_l$chan text "$ctle_dc"
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 3
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set ctle_ac [expr [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] >> 3] & 0xF]
	dashboard_set_property $dash conv_ctleac_l$chan text "$ctle_ac"
	
	#  Test bus = ADP 171[4:1]=1
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPBLOCK] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x1E 0x16
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 7
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set tap1 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x7F]
    if {$tap1 & 0x40} {
        set tap1 [expr -($tap1 & 0x3f)]
    } else {
        set tap1 [expr $tap1 & 0x3f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 8
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set tap2 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x3F]
    if {$tap2 & 0x20} {
         set tap2 [expr -($tap2 & 0x1f)]
    } else {
       
		set tap2 [expr $tap2 & 0x1f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 9
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set tap3 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x3F]
    if {$tap3 & 0x20} {
        
		set tap3 [expr -($tap3 & 0x1f)]
    } else {
        set tap3 [expr $tap3 & 0x1f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 10
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set tap4 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap4 & 0x10} {
        set tap4 [expr -($tap4 & 0xf)]
    } else {
        
		set tap4 [expr $tap4 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 11
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set tap5 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap5 & 0x10} {
         set tap5 [expr -($tap5 & 0xf)]
    } else {
       
		set tap5 [expr $tap5 & 0xf]
    }
   
    reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 12
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
    set tap6 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap6 & 0x10} {
        set tap6 [expr -($tap6 & 0xf)]
    } else {
        
		set tap6 [expr $tap6 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 13
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
	set tap7 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]] & 0x1F]
	if {$tap7 & 0x10} {
        set tap7 [expr -($tap7 & 0xf)]
    } else {
        
		set tap7 [expr $tap7 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 14
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
	set tap8_tap9 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]]
	set tap8 [expr $tap8_tap9 & 0x7]
	if {$tap8 & 0x4} {
        set tap8 [expr -($tap8 & 0x3)]
    } else {
        
		set tap8 [expr $tap8 & 0x3]
    }
	set tap9 [expr [expr $tap8_tap9 >> 3] & 0xF]
	if {$tap9 & 0x8} {
        set tap9 [expr -($tap9 & 0x7)]
    } else {
        
		set tap9 [expr $tap9 & 0x7]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 15
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
	set tap10_tap11 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]]
	set tap10 [expr $tap10_tap11 & 0xF]
	if {$tap10 & 0x8} {
        set tap10 [expr -($tap10 & 0x7)]
    } else {
        
		set tap10 [expr $tap10 & 0x7]
    }
	set tap11 [expr [expr $tap10_tap11 >> 4] & 0xF]
	if {$tap11 & 0x8} {
        set tap11 [expr -($tap11 & 0x7)]
    } else {
        
		set tap11 [expr $tap11 & 0x7]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 16
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
	set tap12_tap13 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]]
	set tap12 [expr $tap12_tap13 & 0xF]
	if {$tap12 & 0x8} {
        set tap12 [expr -($tap12 & 0x7)]
    } else {
        
		set tap12 [expr $tap12 & 0x7]
    }
	set tap13 [expr [expr $tap12_tap13 >> 4] & 0xF]
	if {$tap13 & 0x8} {
        set tap13 [expr -($tap13 & 0x7)]
    } else {
        
		set tap13 [expr $tap13 & 0x7]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0x3F 17
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO] 0
	set tap14_tap15 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_100g_0 OFFSET_S10RECO]]
	set tap14 [expr $tap14_tap15 & 0xF]
	if {$tap14 & 0x8} {
        set tap14 [expr -($tap14 & 0x7)]
    } else {
        
		set tap14 [expr $tap14 & 0x7]
    }
	set tap15 [expr [expr $tap14_tap15 >> 4] & 0xF]
	if {$tap15 & 0x8} {
        set tap15 [expr -($tap15 & 0x7)]
    } else {
        
		set tap15 [expr $tap15 & 0x7]
    }
	
	dashboard_set_property $dash conv_dfe_l$chan text "$tap1, $tap2, $tap3, $tap4, $tap5, $tap6, $tap7, $tap8, $tap9, $tap10, $tap11, $tap12, $tap13, $tap14, $tap15"
	if {$htile_prod_enabled} {
	reconfig_reg_write $chan 0x542 0x10000 0x1
	}
}

proc proc_trigger_adapt {} {
	global dash
	global iadpt_set

	if {[string match [dashboard_get_property $dash trigger_adapt_button text] "Start Adaptation"]} {
		dashboard_set_property $dash trigger_adapt_button text "Stop Adaptation"
		set iadpt_set 1
		proc_trigger_adapt_htile
		
	} elseif {[string match [dashboard_get_property $dash trigger_adapt_button text] "Stop Adaptation"]} {
		dashboard_set_property $dash trigger_adapt_button text "Start Adaptation"
		set iadpt_set 0
		proc_trigger_adapt_htile
	}
	
	

}

proc proc_trigger_adapt_htile {} {
	global ip_sub_variant_option
	
	iadpt_control 0x10000
	iadpt_control 0x11000
	if {$ip_sub_variant_option == "100g_nrz"} {
	iadpt_control 0x12000
	iadpt_control 0x13000
	}
	
}

# ================================================================== 
# 	XCVR RECONFIG
# ==================================================================
dict set MAIN_DICT_s10_100g_0 ADDR_LT_ADAPBLOCK 0x171
dict set MAIN_DICT_s10_100g_0 ADDR_LT_ADAPWRITE 0x149
dict set MAIN_DICT_s10_100g_0 ADDR_LT_ADAPREAD 0x17E
dict set MAIN_DICT_s10_100g_0 ADDR_LT_VOD 0x109
dict set MAIN_DICT_s10_100g_0 ADDR_LT_POST 0x105
dict set MAIN_DICT_s10_100g_0 ADDR_LT_PRE 0x107

# ================================================================== 
# 	General 40GBASE-KR4/CR4 Registers
# ==================================================================
#
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04B0	0x00B0
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04B1	0x00B1
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04B2	0x00B2
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04B5	0x00B5
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04B8	0x00B8
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04BB	0x00BB

# ================================================================== 
# 	Auto-negotiation Registers
# ==================================================================
#
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C0	0x00C0
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C1	0x00C1
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C2	0x00C2
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C3	0x00C3
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C4	0x00C4
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C5	0x00C5
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C6	0x00C6
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C7	0x00C7
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C8	0x00C8
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04C9	0x00C9
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04CA	0x00CA
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04CB	0x00CB

# ================================================================== 
# 	Link training Registers
# ==================================================================
#
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04D0	0x00D0
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04D1	0x00D1
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04D2	0x00D2
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04D3	0x00D3
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04D4	0x00D4
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04D5	0x00D5
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04D6	0x00D6

dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E0	0x00E0
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E1	0x00E1
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E2	0x00E2
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E3	0x00E3
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E4	0x00E4
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E5	0x00E5
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E6	0x00E6
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E7	0x00E7
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E8	0x00E8
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04E9	0x00E9
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04EA	0x00EA
dict set MAIN_DICT_s10_100g_0 ADDR_KR_04EB	0x00EB

# ================================================================== 
# 	PHY-PCS Registers
# ==================================================================
#
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_REVID    0x0300
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_SCRTCH   0x0301
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_IPNAME2  0x0302
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_IPNAME1  0x0303
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_IPNAME0  0x0304
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_PMACFG   0x0310
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_WORDLCK  0x0312
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_PMALOOP  0x0313
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_PHYFSEL  0x0314
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_PHYFLAG  0x0315
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_FREQLOCK 0x0321
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_PHYCLK   0x0322
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_FRMERROR 0x0323
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_CLRFRMER 0x0324
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_SFTRESET 0x0325
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_FALIGNED 0x0326
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_AMLOCK   0x0328
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_LNDSKWED 0x0329
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_PCSVLANE 0x0330
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_RFCLKHZ  0x0340
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_RXCLKHZ  0x0341
dict set MAIN_DICT_s10_100g_0 ADDR_PHY_TXCLKHZ  0x0342

# ================================================================== 
# 	TX MAC Registers
# ==================================================================
#
#
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_REVID			0x0400
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_SCRATCH			0x0401
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_NAME0			0x0402
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_NAME1			0x0403
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_NAME2			0x0404
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_LINKFAULT		0x0405
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_IPGCOLREM		0x0406
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_MAXSIZECONFIG	0x0407
dict set MAIN_DICT_s10_100g_0 ADDR_TXMAC_CONTROL			0x040A

# ================================================================== 
# 	RX MAC Registers
# ==================================================================
#
#
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_REVID			0x0500
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_SCRATCH			0x0501
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_NAME0			0x0502
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_NAME1			0x0503
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_NAME2			0x0504
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_MAXSIZECONFIG	0x0506
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_CRCCONFIG		0x0507
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_LINKFAULT		0x0508
dict set MAIN_DICT_s10_100g_0 ADDR_RXMAC_CONTROL			0x050A

# ================================================================== 
# 	TX Statistics Registers Base
# ==================================================================
dict set MAIN_DICT_s10_100g_0 TX_BASE_STATS 0x800
dict set MAIN_DICT_s10_100g_0  TX_REG_FRAGMENTS_LO       0x800
dict set MAIN_DICT_s10_100g_0  TX_REG_FRAGMENTS_HI       0x801
dict set MAIN_DICT_s10_100g_0  TX_REG_JABBERS_LO         0x802
dict set MAIN_DICT_s10_100g_0  TX_REG_JABBERS_HI         0x803
dict set MAIN_DICT_s10_100g_0  TX_REG_CRCERR_LO          0x804
dict set MAIN_DICT_s10_100g_0  TX_REG_CRCERR_SIZEOK_HI   0x805
dict set MAIN_DICT_s10_100g_0  TX_REG_CRCERR_SIZEOK_LO   0x806
dict set MAIN_DICT_s10_100g_0  TX_REG_CRCERR_HI          0x807
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_DATA_ERR_LO  0x808
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_DATA_ERR_HI  0x809
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_DATA_ERR_LO  0x80A
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_DATA_ERR_HI  0x80B
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_DATA_ERR_LO  0x80C
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_DATA_ERR_HI  0x80D
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_CTRL_ERR_LO  0x80E
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_CTRL_ERR_HI  0x80F
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_CTRL_ERR_LO  0x810
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_CTRL_ERR_HI  0x811
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_CTRL_ERR_LO  0x812
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_CTRL_ERR_HI  0x813
dict set MAIN_DICT_s10_100g_0  TX_REG_PAUSE_ERR_LO       0x814
dict set MAIN_DICT_s10_100g_0  TX_REG_PAUSE_ERR_HI       0x815
dict set MAIN_DICT_s10_100g_0  TX_REG_64B_LO             0x816
dict set MAIN_DICT_s10_100g_0  TX_REG_64B_HI             0x817
dict set MAIN_DICT_s10_100g_0  TX_REG_65to127B_LO        0x818
dict set MAIN_DICT_s10_100g_0  TX_REG_65to127B_HI        0x819
dict set MAIN_DICT_s10_100g_0  TX_REG_128to255B_LO       0x81A
dict set MAIN_DICT_s10_100g_0  TX_REG_128to255B_HI       0x81B
dict set MAIN_DICT_s10_100g_0  TX_REG_256to511B_LO       0x81C
dict set MAIN_DICT_s10_100g_0  TX_REG_256to511B_HI       0x81D
dict set MAIN_DICT_s10_100g_0  TX_REG_512to1023B_LO      0x81E
dict set MAIN_DICT_s10_100g_0  TX_REG_512to1023B_HI      0x81F
dict set MAIN_DICT_s10_100g_0  TX_REG_1024to1518B_LO     0x820
dict set MAIN_DICT_s10_100g_0  TX_REG_1024to1518B_HI     0x821
dict set MAIN_DICT_s10_100g_0  TX_REG_1519toMAXB_LO      0x822
dict set MAIN_DICT_s10_100g_0  TX_REG_1519toMAXB_HI      0x823
dict set MAIN_DICT_s10_100g_0  TX_REG_OVERSIZE_LO        0x824
dict set MAIN_DICT_s10_100g_0  TX_REG_OVERSIZE_HI        0x825
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_DATA_OK_LO   0x826
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_DATA_OK_HI   0x827
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_DATA_OK_LO   0x828
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_DATA_OK_HI   0x829
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_DATA_OK_LO   0x82A
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_DATA_OK_HI   0x82B
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_CTRL_OK_LO   0x82C
dict set MAIN_DICT_s10_100g_0  TX_REG_MCAST_CTRL_OK_HI   0x82D
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_CTRL_OK_LO   0x82E
dict set MAIN_DICT_s10_100g_0  TX_REG_BCAST_CTRL_OK_HI   0x82F
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_CTRL_OK_LO   0x830
dict set MAIN_DICT_s10_100g_0  TX_REG_UCAST_CTRL_OK_HI   0x831
dict set MAIN_DICT_s10_100g_0  TX_REG_PAUSE_LO          0x832
dict set MAIN_DICT_s10_100g_0  TX_REG_PAUSE_HI          0x833
dict set MAIN_DICT_s10_100g_0  TX_REG_RNT_LO            0x834
dict set MAIN_DICT_s10_100g_0  TX_REG_RNT_HI            0x835

dict set MAIN_DICT_s10_100g_0 TX_REG_STAT_CFG		0x845
dict set MAIN_DICT_s10_100g_0 TX_REG_STAT_STATUS		0x846

# ================================================================== 
# 	RX Statistics Registers Base
# ==================================================================
dict set MAIN_DICT_s10_100g_0 RX_BASE_STATS 0x900
dict set MAIN_DICT_s10_100g_0  RX_REG_FRAGMENTS_LO       0x900
dict set MAIN_DICT_s10_100g_0  RX_REG_FRAGMENTS_HI       0x901
dict set MAIN_DICT_s10_100g_0  RX_REG_JABBERS_LO         0x902
dict set MAIN_DICT_s10_100g_0  RX_REG_JABBERS_HI         0x903
dict set MAIN_DICT_s10_100g_0  RX_REG_CRCERR_LO          0x904
dict set MAIN_DICT_s10_100g_0  RX_REG_CRCERR_SIZEOK_HI   0x905
dict set MAIN_DICT_s10_100g_0  RX_REG_CRCERR_SIZEOK_LO   0x906
dict set MAIN_DICT_s10_100g_0  RX_REG_CRCERR_HI          0x907
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_DATA_ERR_LO  0x908
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_DATA_ERR_HI  0x909
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_DATA_ERR_LO  0x90A
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_DATA_ERR_HI  0x90B
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_DATA_ERR_LO  0x90C
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_DATA_ERR_HI  0x90D
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_CTRL_ERR_LO  0x90E
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_CTRL_ERR_HI  0x90F
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_CTRL_ERR_LO  0x910
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_CTRL_ERR_HI  0x911
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_CTRL_ERR_LO  0x912
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_CTRL_ERR_HI  0x913
dict set MAIN_DICT_s10_100g_0  RX_REG_PAUSE_ERR_LO       0x914
dict set MAIN_DICT_s10_100g_0  RX_REG_PAUSE_ERR_HI       0x915
dict set MAIN_DICT_s10_100g_0  RX_REG_64B_LO             0x916
dict set MAIN_DICT_s10_100g_0  RX_REG_64B_HI             0x917
dict set MAIN_DICT_s10_100g_0  RX_REG_65to127B_LO        0x918
dict set MAIN_DICT_s10_100g_0  RX_REG_65to127B_HI        0x919
dict set MAIN_DICT_s10_100g_0  RX_REG_128to255B_LO       0x91A
dict set MAIN_DICT_s10_100g_0  RX_REG_128to255B_HI       0x91B
dict set MAIN_DICT_s10_100g_0  RX_REG_256to511B_LO       0x91C
dict set MAIN_DICT_s10_100g_0  RX_REG_256to511B_HI       0x91D
dict set MAIN_DICT_s10_100g_0  RX_REG_512to1023B_LO      0x91E
dict set MAIN_DICT_s10_100g_0  RX_REG_512to1023B_HI      0x91F
dict set MAIN_DICT_s10_100g_0  RX_REG_1024to1518B_LO     0x920
dict set MAIN_DICT_s10_100g_0  RX_REG_1024to1518B_HI     0x921
dict set MAIN_DICT_s10_100g_0  RX_REG_1519toMAXB_LO      0x922
dict set MAIN_DICT_s10_100g_0  RX_REG_1519toMAXB_HI      0x923
dict set MAIN_DICT_s10_100g_0  RX_REG_OVERSIZE_LO        0x924
dict set MAIN_DICT_s10_100g_0  RX_REG_OVERSIZE_HI        0x925
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_DATA_OK_LO   0x926
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_DATA_OK_HI   0x927
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_DATA_OK_LO   0x928
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_DATA_OK_HI   0x929
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_DATA_OK_LO   0x92A
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_DATA_OK_HI   0x92B
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_CTRL_OK_LO   0x92C
dict set MAIN_DICT_s10_100g_0  RX_REG_MCAST_CTRL_OK_HI   0x92D
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_CTRL_OK_LO   0x92E
dict set MAIN_DICT_s10_100g_0  RX_REG_BCAST_CTRL_OK_HI   0x92F
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_CTRL_OK_LO   0x930
dict set MAIN_DICT_s10_100g_0  RX_REG_UCAST_CTRL_OK_HI   0x931
dict set MAIN_DICT_s10_100g_0  RX_REG_PAUSE_LO          0x932
dict set MAIN_DICT_s10_100g_0  RX_REG_PAUSE_HI          0x933
dict set MAIN_DICT_s10_100g_0  RX_REG_RNT_LO            0x934
dict set MAIN_DICT_s10_100g_0  RX_REG_RNT_HI            0x935

dict set MAIN_DICT_s10_100g_0 RX_REG_STAT_CFG		0x945
dict set MAIN_DICT_s10_100g_0 RX_REG_STAT_STATUS		0x946

#==============================================================================
proc proc_create_dash {} {
	
	global dash
	
	widget_label 0 select_ip_option_note select_ip_option "Plotting link monitor user interface ... please wait!!"
	dashboard_set_property $dash select_ip_option_note foregroundColor red
	dashboard_s10_100g_0
	widget_label 0 select_ip_option_note select_ip_option "Link monitor user interface ready to use!!"
	dashboard_set_property $dash select_ip_option_note foregroundColor blue

}