#Sourcing Other Interface Files
source common_proc.tcl
#Declarations
global dash
global ip_variant_top_option
global ip_variant_option
global ip_sub_variant_top_option
global ip_sub_variant_option
global top_rs_enabled 
global top_anlt_enabled
global rs_enabled
global anlt_enabled
global set_jtag_master


set set_jtag_master 0

incr rep; 
set dash [add_service dashboard Ethernet_Link_Inspector_Monitor_v2p0$rep "ELI - Link Monitor v4.1" "Tools/ELI - Link Monitor v4.1"]

#IP Specific Options

proc proc_ip_variant {} {

global dash
global ip_variant_top_option
	
	
	dashboard_set_property $dash rsfec_suboption text "RS-FEC"
	widget_label 0 select_ip_option_note select_ip_option ""
	
	if {[string match [dashboard_get_property $dash ip_options selectedItem] "None"]} {
		dashboard_set_property $dash launch enabled false
	} else {
		dashboard_set_property $dash launch enabled true
	}
	
	
	if {[string match [dashboard_get_property $dash ip_options selectedItem] "None"]} {
		set ip_variant_top_option "none"
		dashboard_set_property $dash ip_variant options {"None"}
		
		
	} elseif {[string match [dashboard_get_property $dash ip_options selectedItem] "S10 E-tile Hard IP for Ethernet"]} {
		set ip_variant_top_option "etile_hip"
		dashboard_set_property $dash ip_variant options {"100G - NRZ" "100G - PAM4" "25G - NRZ" "10G - NRZ"}
		
		
	} elseif {[string match [dashboard_get_property $dash ip_options selectedItem] "S10 10GBase-KR PHY IP (L/H-tile)"]} {
		set ip_variant_top_option "10g_base_kr"
		dashboard_set_property $dash ip_variant options {"10G - NRZ"}
	
	} elseif {[string match [dashboard_get_property $dash ip_options selectedItem] "S10 25G Ethernet IP (L/H-tile)"]} {
		set ip_variant_top_option "25g_soft_ip"
		dashboard_set_property $dash ip_variant options {"25G - NRZ"}
				
	} elseif {[string match [dashboard_get_property $dash ip_options selectedItem] "S10 Low Latency 40G Ethernet IP (L/H-tile)"]} {
		set ip_variant_top_option "ll_40g"
		dashboard_set_property $dash ip_variant options {"40G - NRZ"}
		
	} elseif {[string match [dashboard_get_property $dash ip_options selectedItem] "S10 Low Latency 100G Ethernet IP (L/H-tile)"]} {
		set ip_variant_top_option "ll_100g"	
		dashboard_set_property $dash ip_variant options {"100G - NRZ"}
		
	} elseif {[string match [dashboard_get_property $dash ip_options selectedItem] "S10 H-Tile Hard IP for Ethernet"]} {
		set ip_variant_top_option "htile_hip"
		dashboard_set_property $dash ip_variant options {"100G - NRZ" "50G - NRZ"}
		
	}

}

proc proc_ip_sub_options {} {

global dash
global ip_variant_top_option

	if {$ip_variant_top_option == "none"} {
		dashboard_set_property $dash rsfec_suboption enabled false
		dashboard_set_property $dash anlt_suboption enabled false	
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption checked false
	} elseif {$ip_variant_top_option == "etile_hip"} {
		proc_etile_hard_ip_sub_options
				
	} elseif {$ip_variant_top_option == "10g_base_kr"} {
		proc_10_g_base_kr_ip_sub_options
	
	} elseif {$ip_variant_top_option == "25g_soft_ip"} {
		proc_25g_soft_ip_sub_options
			
	} elseif {$ip_variant_top_option == "ll_40g"} {
		proc_ll_40_g_sub_options
		
	} elseif {$ip_variant_top_option == "ll_100g"} {
		proc_ll_100_g_sub_options
		
	} elseif {$ip_variant_top_option == "htile_hip"} {
		proc_htile_hard_ip_sub_options
		
	} 	

}  

proc proc_etile_hard_ip_sub_options {} {

global dash
global ip_sub_variant_top_option
global top_rs_enabled
global top_anlt_enabled
	
	set top_rs_enabled 0
	set top_anlt_enabled 0		
	
	if {[string match [dashboard_get_property $dash ip_variant selectedItem] "100G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "RS-FEC(528,514)"
		dashboard_set_property $dash rsfec_suboption enabled true
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false
		set ip_sub_variant_top_option "100g_nrz"
		
			
	} elseif {[string match [dashboard_get_property $dash ip_variant selectedItem] "100G - PAM4"]} {
		dashboard_set_property $dash rsfec_suboption text "RS-FEC(544,514)"
		dashboard_set_property $dash rsfec_suboption enabled false
		dashboard_set_property $dash rsfec_suboption checked true
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false	
		set ip_sub_variant_top_option "100g_pam4"
		set top_rs_enabled 1
					
	} elseif {[string match [dashboard_get_property $dash ip_variant selectedItem] "25G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "RS-FEC(528,514)"
		dashboard_set_property $dash rsfec_suboption enabled true
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false	
		set ip_sub_variant_top_option "25g_nrz"
			
	} elseif {[string match [dashboard_get_property $dash ip_variant selectedItem] "10G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "Fire Code FEC(2112,2080)"
		dashboard_set_property $dash rsfec_suboption enabled false
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false	
		set ip_sub_variant_top_option "10g_nrz"
			
	}
}

proc proc_10_g_base_kr_ip_sub_options {} {

global dash
global ip_sub_variant_top_option
global top_rs_enabled
global top_anlt_enabled


	set top_rs_enabled 0
	set top_anlt_enabled 0		
	

	if {[string match [dashboard_get_property $dash ip_variant selectedItem] "10G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "Fire Code FEC(2112,2080)"
		dashboard_set_property $dash rsfec_suboption enabled true
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled false		
		dashboard_set_property $dash anlt_suboption checked true
		set ip_sub_variant_top_option "10g_nrz"
		set top_anlt_enabled 1	
	} 
	
}

proc proc_25g_soft_ip_sub_options {} {

global dash
global ip_sub_variant_top_option
global top_rs_enabled
global top_anlt_enabled
	
	set top_rs_enabled 0
	set top_anlt_enabled 0
	
	if {[string match [dashboard_get_property $dash ip_variant selectedItem] "25G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "RS-FEC(528,514)"
		dashboard_set_property $dash rsfec_suboption enabled true
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled false
		dashboard_set_property $dash anlt_suboption checked false
		set ip_sub_variant_top_option "25g_nrz"
			
	} 
}
proc proc_ll_40_g_sub_options {} {

global dash
global ip_sub_variant_top_option
global top_rs_enabled
global top_anlt_enabled
	
	set top_rs_enabled 0
	set top_anlt_enabled 0
	
	if {[string match [dashboard_get_property $dash ip_variant selectedItem] "40G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "Fire Code FEC(2112,2080)"
		dashboard_set_property $dash rsfec_suboption enabled true
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false		
		set ip_sub_variant_top_option "40g_nrz"		
	} 	
	
}

proc proc_ll_100_g_sub_options {} {

global dash
global ip_sub_variant_top_option
global top_rs_enabled
global top_anlt_enabled
	
	set top_rs_enabled 0
	set top_anlt_enabled 0
	
	if {[string match [dashboard_get_property $dash ip_variant selectedItem] "100G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "RS-FEC(528,514)"
		dashboard_set_property $dash rsfec_suboption enabled true
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false	
		set ip_sub_variant_top_option "100g_nrz"
	} 	
	
}

proc proc_htile_hard_ip_sub_options {} {

global dash
global ip_sub_variant_top_option
global top_rs_enabled
global top_anlt_enabled
	
	set top_rs_enabled 0
	set top_anlt_enabled 0
	
	if {[string match [dashboard_get_property $dash ip_variant selectedItem] "100G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption text "RS-FEC(528,514)"
		dashboard_set_property $dash rsfec_suboption enabled false
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false
		
		set ip_sub_variant_top_option "100g_nrz"			
			
	} elseif {[string match [dashboard_get_property $dash ip_variant selectedItem] "50G - NRZ"]} {
		dashboard_set_property $dash rsfec_suboption enabled false
		dashboard_set_property $dash rsfec_suboption checked false
		dashboard_set_property $dash anlt_suboption enabled true
		dashboard_set_property $dash anlt_suboption checked false		
		set ip_sub_variant_top_option "50g_nrz"
	}	
	
}
proc launch_proc {} {

global dash
global ip_variant_top_option
global ip_sub_variant_top_option
global ip_variant_option
global ip_sub_variant_option
global top_rs_enabled
global top_anlt_enabled
global rs_enabled
global anlt_enabled
global jtag_master
global set_jtag_master
	
	set ip_variant_option $ip_variant_top_option
	set ip_sub_variant_option $ip_sub_variant_top_option
	set rs_enabled $top_rs_enabled
	set anlt_enabled $top_anlt_enabled
	
	dashboard_remove $dash ip_tab
	
	if {$jtag_master == "" | $set_jtag_master == 0} {
			
			widget_label 0 set_jtag_note select_ip_option "3. Select the JTAG Master number from the drop down menu and click 'Set JTAG Master'"
			dashboard_set_property $dash set_jtag_note foregroundColor red
			
				#widget_group 1 ip_tab topGroup_2 1 ""	
			
	
	} else {
	
			widget_label 0 set_jtag_note select_ip_option "3. Select the JTAG Master number from the drop down menu and click 'Set JTAG Master'"
			dashboard_set_property $dash set_jtag_note foregroundColor blue
			
	}
	
	if {$ip_variant_top_option == "none"} {
			
			
			dashboard_set_property $dash select_ip_option_note foregroundColor red
			
		} elseif {$ip_variant_top_option == "etile_hip"} {
			
			widget_group 1 ip_tab topGroup_2 1 ""
			if {$ip_sub_variant_top_option == "100g_pam4" | $ip_sub_variant_top_option == "100g_nrz"} {			
				source e_tile_hardip_100g.tcl
			} elseif {$ip_sub_variant_top_option == "25g_nrz" | $ip_sub_variant_top_option == "10g_nrz"} {
				source e_tile_hardip_25g_10g.tcl
			}	
			proc_create_dash 
				
		
		} elseif {$ip_variant_top_option == "10g_base_kr"} {
		
			widget_group 1 ip_tab topGroup_2 1 ""
			source 10g_kr_phy.tcl
			proc_create_dash 
		
			
		
		} elseif {$ip_variant_top_option == "25g_soft_ip"} {
			
			widget_group 1 ip_tab topGroup_2 1 ""
			source s10_25g.tcl
			proc_create_dash 
				
		
		} elseif {$ip_variant_top_option == "ll_40g"} {
			
			widget_group 1 ip_tab topGroup_2 1 ""
			source s10_ll_40g.tcl
			proc_create_dash 
			
		} elseif {$ip_variant_top_option == "ll_100g"} {
			
			
			if {$ip_sub_variant_top_option == "100g_nrz"} {
				widget_label 0 select_ip_option_note select_ip_option "LL100G(Soft) L/H Tile Link Monitor is available in Quartus 18.1 & beyond"
				dashboard_set_property $dash select_ip_option_note foregroundColor blue
			}
			widget_group 1 ip_tab topGroup_2 1 ""	
			
		
		} elseif {$ip_variant_top_option == "htile_hip"} {
			
			widget_group 1 ip_tab topGroup_2 1 ""
			source htile_hardip.tcl
			proc_create_dash 
			
		
		}
	
	
	
	

}

proc proc_rsfec {} {

global dash
global top_rs_enabled 

	if { [dashboard_get_property $dash rsfec_suboption checked] } {
		set top_rs_enabled 1
		puts "Fec Enabled"
	} else {
		set top_rs_enabled 0
		puts "Fec Disabled"
	}
}

proc proc_anlt {} {

global dash
global top_anlt_enabled 

	if { [dashboard_get_property $dash anlt_suboption checked] } {
		set top_anlt_enabled 1
		puts "Anlt Enabled"
	} else {
		set top_anlt_enabled 0
		puts "Anlt Disabled"
	}
}

#Dashboard GUI 
dashboard_set_property $dash self visible true
dashboard_set_property $dash self visible true
widget_group 1 masterGroup self 1 ""

	widget_group 1 topGroup_1 masterGroup 1 ""
	widget_group 1 topGroup_2 masterGroup 1 ""
	
		widget_group 1 topGroup_1_1 topGroup_1 1 ""
		
			widget_group 1 jtag_master_select topGroup_1_1 1 "JTAG Master Selection"
				
				widget_group 1 list_set_jtag jtag_master_select 3 ""
					widget_button 1 list_jtag list_set_jtag "List JTAG Masters" list_jtag_proc
					widget_button 1 set_jtag list_set_jtag "Set JTAG Master" set_jtag_proc
					widget_comboBox 1 set_jtag_value list_set_jtag "--"
				
				#widget_textBox 1 jtag_master jtag_master_select 0 "---" 
				widget_textBox 1 jtag_master jtag_master_select 0 "---" 160 1100
				
				widget_groupWidth 1 selected_jtag_master jtag_master_select 2 "Currently selected master is:" 500
					widget_label 1 selected_jtag_master_2 selected_jtag_master "---"
					widget_label 1 selected_jtag_master_3 selected_jtag_master ""
						dashboard_set_property $dash selected_jtag_master_3 preferredWidth 500
						#dashboard_set_property $dash selected_jtag_master_3 
						
				#widget_groupHeight 1 jtag_master_select_dummy jtag_master_select 1 "" 5		

		
		widget_group 1 topGroup_1_2 topGroup_1 2 ""
		
			widget_group 1 select_ip_option topGroup_1_2 1 "Select IP Variant"
			
			widget_group 1 select_ip_option_1 select_ip_option 3 ""
				widget_comboBoxonChange 1 ip_options select_ip_option_1 {"None" "S10 10GBase-KR PHY IP (L/H-tile)" "S10 25G Ethernet IP (L/H-tile)" "S10 Low Latency 40G Ethernet IP (L/H-tile)" "S10 Low Latency 100G Ethernet IP (L/H-tile)" "S10 H-Tile Hard IP for Ethernet" "S10 E-tile Hard IP for Ethernet"} proc_ip_variant
				widget_comboBoxonChange 1 ip_variant select_ip_option_1 {"None"} proc_ip_sub_options
				widget_button 1 launch select_ip_option_1 "Launch" launch_proc
					dashboard_set_property $dash launch enabled false
				
			widget_group 1 select_ip_sub_option select_ip_option 2 ""
				widget_checkBox 1  rsfec_suboption select_ip_sub_option "RS-FEC" proc_rsfec
				widget_checkBox 1  anlt_suboption select_ip_sub_option "KR (AN & LT)" proc_anlt
				dashboard_set_property $dash rsfec_suboption enabled false
				dashboard_set_property $dash anlt_suboption enabled false
						
			widget_group 1 select_ip_option_2 select_ip_option 1 ""
				widget_label 1 select_ip_option_note select_ip_option_2 ""
					
					
			widget_group 1 instructions topGroup_1_2 1 "Instructions"
				widget_label 1 load_sof instructions "1. Load Programming File(*.SOF) in system console (FILE->LOAD DESIGN) for detailed JTAG Master path"
					dashboard_set_property $dash load_sof foregroundColor blue
				widget_label 1 list_jtag_note instructions	"2. Click button 'List JTAG Masters' to see all available JTAG Masters"
					dashboard_set_property $dash list_jtag_note foregroundColor blue
				widget_label 1 set_jtag_note instructions	"3. Select the JTAG Master number from the drop down menu and click 'Set JTAG Master'"
					dashboard_set_property $dash set_jtag_note foregroundColor blue
				widget_label 1 select_ip_note instructions	"4. Select IP Variant from the drop-down and click Launch to populate the Link monitor user interface"
					dashboard_set_property $dash select_ip_note foregroundColor blue
				widget_groupHeight 1 instructions_dummy instructions 1 "" 40		
					

		widget_group 1 ip_tab topGroup_2 1 ""			
				
		
#list_jtag_proc				
#open_port			
		