
global MAIN_DICT_s10_40g_0
global BASE_LL40G

set BASE_LL40G 0x0


dict set MAIN_DICT_s10_40g_0 OFFSET_S10CSR 0x0
dict set MAIN_DICT_s10_40g_0 OFFSET_S10RECO 0x4000

proc dashboard_s10_40g_0 {} {
	global dash
	global anlt_enabled	
	global rs_enabled
	global htile_prod_enabled
	
	widget_group 1  topGroup ip_tab 1 "Stratix 10 Low Latency 40-Gbps Ethernet IP"
	
		widget_checkBox 1  continuous_read topGroup "Continuous Read All Registers" proc_continuous_read
				
			widget_group 1 tx_rx_status topGroup 5 ""
				widget_label 1 txpcsready_ll_40g tx_rx_status "TX MAC & PHY Ready"
				dashboard_set_property $dash txpcsready_ll_40g toolTip "MAC stats are applicable only when device is in DATA mode (completed AN & LT)" 
				widget_led 1 txpcsready_stat tx_rx_status "" black 	
				dashboard_set_property $dash txpcsready_stat toolTip "MAC stats are applicable only when device is in DATA mode (completed AN & LT)"
				
				widget_label 1 dummy_space tx_rx_status "         "
				widget_label 1 rxpcsaligned_ll_40g tx_rx_status "RX PCS Fully Aligned"
				widget_led 1 rxpcs_stat tx_rx_status "" black	
		
			
		dashboard_add $dash allstatus tabbedGroup topGroup
	
			#
			#MAC & PCS
			#
			widget_group 1  MAC_PCS allstatus 1 "MAC & PCS"
			
				widget_group 1  reset_mac_pcs MAC_PCS 3 "Resets"
					widget_button 1  full_sys_rst reset_mac_pcs "Assert Full System Reset" proc_full_sys_rst
					widget_button 1  soft_txp_rst reset_mac_pcs "Assert TX MAC & PCS Reset" proc_soft_txp_rst
					widget_button 1  soft_rxp_rst reset_mac_pcs "Assert RX MAC & PCS Reset" proc_soft_rxp_rst
					
				widget_group 1  PCS MAC_PCS 2 "PCS Status"
				
					widget_button 1  read_pcs_status PCS "Read PCS Status" proc_read_pcs_status
					widget_button 1  eio_sloop PCS "Enable Serial PMA Loopback" proc_eio_sloop
						dashboard_set_property $dash eio_sloop toolTip "If KR4 is enabled, this button will set ignore nonce for AN"
					widget_group 1  pcs_dummy_1 PCS 5 ""
						
						widget_label 1   pcs_dummy_1_blank pcs_dummy_1 ""
						widget_label 1   pcs_dummy_1_l0 pcs_dummy_1 "Lane 0"
						widget_label 1   pcs_dummy_1_l1 pcs_dummy_1 "Lane 1"
						widget_label 1   pcs_dummy_1_l2 pcs_dummy_1 "Lane 2"
						widget_label 1   pcs_dummy_1_l3 pcs_dummy_1 "Lane 3"
						
						widget_label 1  wordlock pcs_dummy_1 "Word Lock"
						widget_led 1   wordlock_l0 pcs_dummy_1 ""  black
						widget_led 1   wordlock_l1 pcs_dummy_1 ""  black
						widget_led 1   wordlock_l2 pcs_dummy_1 ""  black
						widget_led 1   wordlock_l3 pcs_dummy_1 ""  black
			
						widget_label 1  rxcdrplllocked pcs_dummy_1 "RX CDR PLL Locked"
						widget_led 1  rxcdrplllocked_l0 pcs_dummy_1 ""  black
						widget_led 1  rxcdrplllocked_l1 pcs_dummy_1 ""  black
						widget_led 1  rxcdrplllocked_l2 pcs_dummy_1 ""  black
						widget_led 1  rxcdrplllocked_l3 pcs_dummy_1 ""  black
						
						widget_label 1  tx_fifo_full pcs_dummy_1 "TX FIFO Full"
						widget_led 1  tx_fifo_full_l0 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_full_l1 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_full_l2 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_full_l3 pcs_dummy_1 ""  black
						
						widget_label 1  tx_fifo_empty pcs_dummy_1 "TX FIFO Empty"
						widget_led 1  tx_fifo_empty_l0 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_empty_l1 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_empty_l2 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_empty_l3 pcs_dummy_1 ""  black
						
						widget_label 1  tx_fifo_pfull pcs_dummy_1 "TX FIFO Partial Full"
							dashboard_set_property $dash tx_fifo_pfull toolTip "YELLOW led color represents the assertion or logic '1'. This is not displayed as RED because toggling of *FIFO Partial* signals is an expected behavior."
						widget_led 1  tx_fifo_pfull_l0 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_pfull_l1 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_pfull_l2 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_pfull_l3 pcs_dummy_1 ""  black
						
						widget_label 1  tx_fifo_pempty pcs_dummy_1 "TX FIFO Partial Empty"
							dashboard_set_property $dash tx_fifo_pempty toolTip "YELLOW led color represents the assertion or logic '1'. This is not displayed as RED because toggling of *FIFO Partial* signals is an expected behavior."
						widget_led 1  tx_fifo_pempty_l0 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_pempty_l1 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_pempty_l2 pcs_dummy_1 ""  black
						widget_led 1  tx_fifo_pempty_l3 pcs_dummy_1 ""  black
						
						widget_label 1  rx_fifo_full pcs_dummy_1 "RX FIFO Full"
						widget_led 1  rx_fifo_full_l0 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_full_l1 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_full_l2 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_full_l3 pcs_dummy_1 ""  black
						
						widget_label 1  rx_fifo_empty pcs_dummy_1 "RX FIFO Empty"
						widget_led 1  rx_fifo_empty_l0 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_empty_l1 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_empty_l2 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_empty_l3 pcs_dummy_1 ""  black
						
						widget_label 1  rx_fifo_pfull pcs_dummy_1 "RX FIFO Partial Full"
							dashboard_set_property $dash rx_fifo_pfull toolTip "YELLOW led color represents the assertion or logic '1'. This is not displayed as RED because toggling of *FIFO Partial* signals is an expected behavior."
						widget_led 1  rx_fifo_pfull_l0 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_pfull_l1 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_pfull_l2 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_pfull_l3 pcs_dummy_1 ""  black
						
						widget_label 1  rx_fifo_pempty pcs_dummy_1 "RX FIFO Partial Empty"
							dashboard_set_property $dash rx_fifo_pempty toolTip "YELLOW led color represents the assertion or logic '1'. This is not displayed as RED because toggling of *FIFO Partial* signals is an expected behavior."
						widget_led 1  rx_fifo_pempty_l0 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_pempty_l1 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_pempty_l2 pcs_dummy_1 ""  black
						widget_led 1  rx_fifo_pempty_l3 pcs_dummy_1 ""  black
		
					widget_group 1  pcs_dummy_2 PCS 2 ""
					
						widget_label 1  txclk_title pcs_dummy_2 "TX Clock (KHz)"
						widget_textBox 1  txclk_stat pcs_dummy_2 0 "0" 7 100
			
						widget_label 1  txpll_title pcs_dummy_2 "TX Core Clock Stable"
						dashboard_set_property $dash txpll_title toolTip "MAC stats are applicable only when device is in DATA mode (completed AN & LT)"					
						widget_led 1  txpll_stat pcs_dummy_2 ""  black
						dashboard_set_property $dash txpll_stat toolTip "MAC stats are applicable only when device is in DATA mode (completed AN & LT)"					
						
						widget_label 1  rxclk_title pcs_dummy_2 "RX Clock (KHz)"
						widget_textBox 1  rxclk_stat pcs_dummy_2 0 "0" 7 100
						
						widget_label 1  rxpll_title pcs_dummy_2 "RX Core Clock Stable"
						widget_led 1  rxpll_stat pcs_dummy_2 ""  black
						
						widget_label 1  lanesdeskewed_title pcs_dummy_2 "Lanes Deskewed"
						widget_led 1  lanesdeskewed_stat pcs_dummy_2 ""  black
						
						widget_label 1  amlock pcs_dummy_2 "Alignment Marker Lock"
						widget_led 1  amlock_stat pcs_dummy_2 ""  black
						
						widget_label 1  frameerror_title pcs_dummy_2 "Frame Error"
						widget_textBox 1  frameerror_stat pcs_dummy_2 0 "0" 7 100			
													
						
				widget_group 1  MAC MAC_PCS 2 ""
				
					widget_group 1  TXMAC MAC 2 "TX MAC Status"
					
						widget_button 1  read_txmac TXMAC "Read TX MAC Status" proc_read_txmac
						widget_label 1  txmac_blank TXMAC ""
						
						widget_label 1  force_remote_fault TXMAC "Force Remote Fault"
						widget_textBox 1  force_remote_fault_text TXMAC 0 "Off" 7 100
						
						widget_label 1  disable_remote_fault TXMAC "Disable Remote Fault"
						widget_textBox 1  disable_remote_fault_text TXMAC 0 "Off" 7 100
						
						widget_label 1  unidir_remote_link_fault_reporting TXMAC "Unidir Remote Link Fault Reporting"
						widget_textBox 1  unidir_remote_link_fault_reporting_text TXMAC 0 "Off" 7 100
						
						widget_label 1  link_fault_reporting TXMAC "Link Fault Reporting"
						widget_textBox 1  link_fault_reporting_text TXMAC 0 "On" 7 100
						
						widget_label 1  idle_col_rem TXMAC "Idle Columns"
						widget_textBox 1  idle_col_rem_text TXMAC 0 "00000000" 7 100
						
						widget_label 1  max_tx_size_config TXMAC "Max TX Size Config"
						widget_textBox 1  max_tx_size_config_text TXMAC 0 "00000000" 7 100
						
						widget_label 1  vlan_detection_tx TXMAC "VLAN Detection"
						widget_textBox 1  vlan_detection_tx_text TXMAC 0 "Enabled" 7 100
						
					widget_group 1  RXMAC MAC 2 "RX MAC Status"
					
						widget_button 1  read_rxmac RXMAC "Read RX MAC Status" proc_read_rxmac
						widget_label 1  rxmac_blank RXMAC ""
						
						widget_label 1  local_fault RXMAC "Local Fault"
							dashboard_set_property $dash local_fault foregroundColor black
						widget_textBox 1  local_fault_text RXMAC 0 "No" 7 100
						
						widget_label 1  remote_fault RXMAC "Remote Fault"
							dashboard_set_property $dash remote_fault foregroundColor black							
						widget_textBox 1  remote_fault_text RXMAC 0 "No" 7 100
						
						
						widget_label 1  mac_crc_config RXMAC "RX CRC Forwarding"
						widget_textBox 1  mac_crc_config_text RXMAC 0 "Removed" 7 100
						
						widget_label 1  preamble_check RXMAC "Preamble Check"
						widget_textBox 1  preamble_check_text RXMAC 0 "On" 7 100
						
						widget_label 1  sfd_check RXMAC "SFD Check"
						widget_textBox 1  sfd_check_text RXMAC 0 "On" 7 100
						
						widget_label 1  max_rx_size_config RXMAC "MAX RX Size Config"
						widget_textBox 1  max_rx_size_config_text RXMAC 0 "00000000" 7 100
						
						widget_label 1  vlan_detection_rx RXMAC "VLAN Detection"
						widget_textBox 1  vlan_detection_rx_text RXMAC 0 "Enabled" 7 100
						
				widget_groupHeight 1 mac_and_pcs_status_dummygroup MAC_PCS 1 "" 610
			
			#
			#Statistics Counters
			#
			widget_group 1  PKT_STATS_COUNT allstatus 1 "Statistics Counters"
				
				packet_generator
				
				widget_group 1  STATS_COUNT_UP PKT_STATS_COUNT 2 ""
				widget_group 1  STATS_COUNT STATS_COUNT_UP 3 "TX & RX Statistics"
				#widget_button 1  pkt_gen STATS_COUNT "Start Packet Generator" proc_pkt_gen
				#widget_label 1  pkt_gen_note STATS_COUNT "Note: Only available when example design is instantiated"
				
				widget_label 1 name_stats_count STATS_COUNT "Statistics Counters Names"
				widget_label 1 txmac_stats_ll STATS_COUNT "TX Statistics Counters"
				widget_label 1 rxmac_stats_ll STATS_COUNT "RX Statistics Counters"
				
				widget_label 1 read_statistics_ll STATS_COUNT ""
				widget_button 1  read_tx_stats STATS_COUNT "Read TX Statistics" proc_read_tx_stats
				widget_button 1  read_rx_stats STATS_COUNT "Read RX Statistics" proc_read_rx_stats
								
				widget_label 1 reset_statistics_ll STATS_COUNT ""
				widget_button 1  reset_tx_stats STATS_COUNT "Reset TX Statistics" proc_reset_tx_stats
				widget_button 1  reset_rx_stats STATS_COUNT "Reset RX Statistics" proc_reset_rx_stats
				
							
					widget_label 1 cntr_fragments STATS_COUNT "Frames < 64 bytes with CRC error"
					widget_textBox 1 cntr_tx_fragments_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_fragments_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_jabbers STATS_COUNT "Oversized frames with CRC error"
					widget_textBox 1 cntr_tx_jabbers_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_jabbers_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_fcs STATS_COUNT "Packets with FCS errors"
					widget_textBox 1 cntr_tx_fcs_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_fcs_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_fcs_err_okpkt STATS_COUNT "Frames >= 64 bytes with CRC error"
					widget_textBox 1 cntr_tx_fcs_err_okpkt_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_fcs_err_okpkt_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_mcast_data_err STATS_COUNT "Multicast data frames with CRC error"
					widget_textBox 1 cntr_tx_mcast_data_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_data_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_bcast_data_err STATS_COUNT "Broadcast data frames with CRC error"
					widget_textBox 1 cntr_tx_bcast_data_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_data_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_ucast_data_err STATS_COUNT "Unicast data frames with CRC error"
					widget_textBox 1 cntr_tx_ucast_data_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_data_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_mcast_ctrl_err STATS_COUNT "Multicast Control frames with CRC error"
					widget_textBox 1 cntr_tx_mcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_bcast_ctrl_err STATS_COUNT "Broadcast Control frames with CRC error"
					widget_textBox 1 cntr_tx_bcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_ucast_ctrl_err STATS_COUNT "Unicast Control frames with CRC error"
					widget_textBox 1 cntr_tx_ucast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_ctrl_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_pause_err STATS_COUNT "Pause frames with CRC error"
					widget_textBox 1 cntr_tx_pause_err_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_pause_err_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_64b STATS_COUNT "64 Byte Frames (includes CRC field)"
					widget_textBox 1 cntr_tx_64b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_64b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_65to127b STATS_COUNT "65 - 127 Byte Frames"
					widget_textBox 1 cntr_tx_65to127b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_65to127b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_128to255b STATS_COUNT "128 - 255 Byte Frames"
					widget_textBox 1 cntr_tx_128to255b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_128to255b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_256to511b STATS_COUNT "256 - 511 Byte Frames"
					widget_textBox 1 cntr_tx_256to511b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_256to511b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_512to1023b STATS_COUNT "512 - 1023 Byte Frames"
					widget_textBox 1 cntr_tx_512to1023b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_512to1023b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_1024to1518b STATS_COUNT "1024 - 1518 Byte Frames"
					widget_textBox 1 cntr_tx_1024to1518b_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_1024to1518b_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_1519tomaxb STATS_COUNT "1519 - MAX Size Frames"
					widget_textBox 1 cntr_tx_1519tomaxb_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_1519tomaxb_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_oversize STATS_COUNT "Oversize Frames (> MAX Size Frames)"
					widget_textBox 1 cntr_tx_oversize_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_oversize_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_mcast_data_ok STATS_COUNT "Multicast data frames without error"
					widget_textBox 1 cntr_tx_mcast_data_ok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_data_ok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_bcast_data_ok STATS_COUNT "Broadcast data frames without error"
					widget_textBox 1 cntr_tx_bcast_data_ok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_data_ok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_ucast_data_ok STATS_COUNT "Unicast data frames without error"
					widget_textBox 1 cntr_tx_ucast_data_ok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_data_ok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_mcast_ctrl STATS_COUNT "Multicast Control frames without error"
					widget_textBox 1 cntr_tx_mcast_ctrl_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_mcast_ctrl_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_bcast_ctrl STATS_COUNT "Broadcast Control frames without error"
					widget_textBox 1 cntr_tx_bcast_ctrl_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_bcast_ctrl_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_ucast_ctrl STATS_COUNT "Unicast Control frames without error"
					widget_textBox 1 cntr_tx_ucast_ctrl_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_ucast_ctrl_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_pause STATS_COUNT "Pause frames without error"
					widget_textBox 1 cntr_tx_pause_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_pause_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_runt STATS_COUNT "Runt Packets"
					widget_textBox 1 cntr_tx_runt_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_runt_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_payloadoctetsok STATS_COUNT "Payload bytes with no errors"
					widget_textBox 1 cntr_tx_payloadoctetsok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_payloadoctetsok_d STATS_COUNT 0 "0" 7 120
					
					widget_label 1 cntr_frameoctetsok STATS_COUNT "Frame bytes with no errors"
					widget_textBox 1 cntr_tx_frameoctetsok_d STATS_COUNT 0 "0" 7 120
					widget_textBox 1 cntr_rx_frameoctetsok_d STATS_COUNT 0 "0" 7 120						
					
				if {$rs_enabled} {
				widget_group 1  FEC_Stats STATS_COUNT_UP 2 "FEC Statistics"
				
					widget_button 1  read_fec_status FEC_Stats "Read FEC Status" proc_read_fec_status
					widget_label 1  dummy_fec_stats FEC_Stats ""
					
					widget_label 1  fec_word_align_title FEC_Stats "FEC Word Align"
					widget_led 1  fec_word_align_data FEC_Stats ""  black	
					
					widget_label 1  corrected_codewords_label FEC_Stats "Corrected Blocks"
					widget_textBox 1  corrected_codewords_data FEC_Stats  0 "" 7 100
					
					widget_label 1  uncorrected_codewords_label FEC_Stats "Uncorrected Blocks"
					widget_textBox 1  uncorrected_codewords_data FEC_Stats  0 "" 7 500
				
				dashboard_set_property $dash FEC_Stats visible false	
				
				}
											
			#
			#PHY
			#
			
			widget_group 1  KR4 allstatus 1 "PMA"
				
				widget_button 1  read_kr4_status KR4 "Read PMA Status" proc_read_kr4_status
				
				#
				# Link Training Parameters
				#
				widget_group 1  LT KR4 5 "PMA"
				
					
					
					
					#widget_button 1 trigger_adapt_button LT "Stop Adaptation"  proc_trigger_adapt
					widget_checkBox 1  htile_prod LT "H-Tile Production Device" proc_htile_prod_enable
					set	htile_prod_enabled 0
					widget_label 1  lt_init LT ""				
					#widget_label 1  lt_init LT ""
					widget_label 1  lt_init LT ""
					widget_label 1  lt_init LT ""
					widget_label 1  lt_init LT ""
					
		
					widget_label 1  lt_blank LT ""
					widget_label 1  lt_l0 LT "Lane 0"
					widget_label 1  lt_l1 LT "Lane 1"
					widget_label 1  lt_l2 LT "Lane 2"
					widget_label 1  lt_l3 LT "Lane 3"
			
					widget_label 1  conv_tx_title LT "Converged TX (vod, post, pre)"
					widget_label 1  conv_tx_l0 LT "0, 0, 0"
					widget_label 1  conv_tx_l1 LT "0, 0, 0"
					widget_label 1  conv_tx_l2 LT "0, 0, 0"
					widget_label 1  conv_tx_l3 LT "0, 0, 0"

					widget_label 1  conv_vga_title LT "Converged VGA"
					widget_label 1  conv_vga_l0 LT "0"
					widget_label 1  conv_vga_l1 LT "0"
					widget_label 1  conv_vga_l2 LT "0"
					widget_label 1  conv_vga_l3 LT "0"

					widget_label 1  conv_ctledc_title LT "Converged CTLE DC"
					widget_label 1  conv_ctledc_l0 LT "0"
					widget_label 1  conv_ctledc_l1 LT "0"
					widget_label 1  conv_ctledc_l2 LT "0"
					widget_label 1  conv_ctledc_l3 LT "0"
					
					widget_label 1  conv_ctleac_title LT "Converged CTLE AC"
					widget_label 1  conv_ctleac_l0 LT "0"
					widget_label 1  conv_ctleac_l1 LT "0"
					widget_label 1  conv_ctleac_l2 LT "0"
					widget_label 1  conv_ctleac_l3 LT "0"

					widget_label 1  conv_dfe_title LT "Converged DFE"
					widget_labelwidth 1  conv_dfe_l0 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
					widget_labelwidth 1  conv_dfe_l1 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
					widget_labelwidth 1  conv_dfe_l2 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
					widget_labelwidth 1  conv_dfe_l3 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0" 225
				
				#widget_group 1  kr4_dummy_1 KR4 3 ""
				
				#
				#Sequencer
				#
				if {$anlt_enabled == 1} {
				
				widget_group 1  kr4_dummy_1 KR4 3 ""
					
					widget_group 1  SEQ kr4_dummy_1 3 "Sequencer"
						
						widget_button 1  reset_seq SEQ "Reset Sequencer"  proc_reset_seq
						widget_label 1   seq_blank_1 SEQ ""
						widget_label 1   seq_blank_2 SEQ ""
			
						widget_label 1   seq_force SEQ "SEQ Force Mode"
						widget_comboBox 1  seq_force_mode SEQ {"No Force" "40GBASE-R4" "40GBASE-KR4/CR4"  "40GBASE-R4 w/FEC"}
						widget_button 1  seq_force SEQ "Force" proc_seq_force
						
						widget_label 1  SEQ_LNK_RDY SEQ "SEQ Link Ready"
						widget_led 1  SEQ_LNK_RDY_LED SEQ ""  black
						widget_label 1   seq_blank_3 SEQ ""
			
						widget_label 1  SEQ_MODE SEQ "SEQ Mode"
						widget_textBox 1  SEQ_RECONFG_MODE SEQ 0 "---" 7 125
						widget_label 1   seq_blank_3 SEQ ""
						
						widget_groupHeight 1 seq_dummygroup SEQ 0 "" 50				
			
					#
					# Auto Negotiation & FEC Parameters
					#
					widget_group 1  AN_FEC kr4_dummy_1 7 "Auto Negotiation & FEC"
					
						widget_group 1  AN AN_FEC 2 "AN"
						
							widget_checkBox 1 ignore_tx_nonce AN "Ignore Nonce Field" proc_ignore_nonce
							widget_label 1  ignore_tx_nonce_dummy AN ""
					
							widget_label 1  an_ena_title AN "AN Enable"
							widget_led 1  an_ena_data AN ""  black
							
							widget_label 1  an_comp_title AN "AN Complete"
							widget_textBox 1  an_comp_data AN 0 "---" 7 125
														
							widget_label 1  an_abi_title AN "AN Ability"
							widget_textBox 1  an_abi_data AN 0 "---" 7 125
							
							widget_label 1  an_stat_title AN "AN Status"
							widget_led 1 	an_stat_data AN ""  black
							
							widget_label 1  seq_an_title AN "SEQ AN"
							widget_textBox 1  seq_an_data AN 0 "---" 7 125
							
							widget_label 1  fi_an_title AN "Final AN Tech"
							widget_textBox 1 fi_an_data AN 0 "---" 7 125
						
						widget_group 1  FEC AN_FEC 5 "FEC"
						
							widget_label 1  fec_ena_title FEC "FEC Enable"
							widget_led 1 	fec_ena_data FEC ""  black
							widget_label 1  fec_blank_r2c3 FEC ""
							widget_label 1  fec_blank_r2c4 FEC ""
							widget_label 1  fec_blank_r2c5 FEC ""
						
							widget_label 1  fec_req_title FEC "FEC Request Enable"
							widget_led 1  fec_req_data FEC ""  black
							widget_label 1  fec_blank_r3c3 FEC ""
							widget_label 1  fec_blank_r3c4 FEC ""
							widget_label 1  fec_blank_r3c5 FEC ""
						
							widget_label 1  fec_abi_title FEC "FEC ability"
							widget_led 1 	fec_abi_data FEC ""  black
							widget_label 1  fec_blank_r4c3 FEC ""
							widget_label 1  fec_blank_r4c4 FEC ""
							widget_label 1  fec_blank_r4c5 FEC ""
							
							widget_label 1  fec_use_title FEC "FEC in use"
							widget_led 1  fec_use_data FEC ""  black
							widget_label 1  fec_blank_r5c3 FEC ""
							widget_label 1  fec_blank_r5c4 FEC ""
							widget_label 1  fec_blank_r5c5 FEC ""
							
							
							widget_label 1  fec_blank FEC ""
							widget_label 1  fec_l0 FEC "Lane 0"
							widget_label 1  fec_l1 FEC "Lane 1"
							widget_label 1  fec_l2 FEC "Lane 2"
							widget_label 1  fec_l3 FEC "Lane 3"
						
							widget_label 1  fec_ena_title FEC "FEC Block Lock"
							widget_led 1 	fec_ena_l0 FEC ""  black
							widget_led 1 	fec_ena_l1 FEC ""  black
							widget_led 1 	fec_ena_l2 FEC ""  black
							widget_led 1 	fec_ena_l3 FEC ""  black
							
							widget_groupHeight 1 fec_dummygroup FEC 1 "" 10				
					
						widget_group 1  LT kr4_dummy_1 2 "LT"	
							
							widget_label 1  lt_ena_title LT "LT Enable"
								widget_led 1  lt_ena_data LT ""  black
								
							widget_groupHeight 1 lt_dummygroup LT 1 "" 120					
				}
				
				if {$anlt_enabled} {
				widget_groupHeight 1 kr4_dummygroup KR4 1 "" 770				
				} else {
				widget_groupHeight 1 kr4_dummygroup KR4 1 "" 975				
				}
				
		help_tab
			
}

proc help_tab {} {

	global dash

	widget_group 1  Help allstatus 1 "Help"	

		widget_group 1 instructions Help 1 "Link Bring Up Guidelines"
		
				widget_label 1 kr_steps instructions "if (KR is enabled) ("					
				dashboard_set_property $dash kr_steps foregroundColor blue			
				widget_label 1 instructions_2 instructions	"      if (Internal Serial Loop-back or External Loop-back) ("
					dashboard_set_property $dash instructions_2 foregroundColor blue			
				widget_label 1 select_ip_note instructions	"            1. Check Ignore Nonce check box in PMA tab"
					#dashboard_set_property $dash select_ip_note foregroundColor blue
				widget_label 1 instructions_1 instructions	"            2. Click Reset sequencer button in PMA tab"
					#dashboard_set_property $dash instructions_1 foregroundColor blue
				widget_label 1 instructions_2a instructions	"            if ( Internal Serial Loop-back) ("
					dashboard_set_property $dash instructions_2a foregroundColor blue
				widget_label 1 instructions_2 instructions	"                  3. Click on Enable Serial PMA Loop-back button in MAC & PCS tab"				
				widget_label 1 instructions_2b instructions	"            )"
					dashboard_set_property $dash instructions_2b foregroundColor blue
				widget_label 1 instructions_2 instructions	"            4. Click on Continuous Read All registers or Read PCS Status. The link should be up"
					#dashboard_set_property $dash instructions_2 foregroundColor blue	
				widget_label 1 instructions_Mis_Kr instructions	"      ) elseif (Connect to Link Partner) ("
					dashboard_set_property $dash instructions_Mis_Kr foregroundColor blue
				widget_label 1 instructions_2 instructions	"            1. Click on Continuous Read All registers or Read PCS Status"
				widget_label 1 instructions_3 instructions	"      )"
					dashboard_set_property $dash instructions_3 foregroundColor blue
				widget_label 1 instructions_3 instructions	")"
					dashboard_set_property $dash instructions_3 foregroundColor blue
				
				
		widget_groupHeight 1 help_status_dummygroup Help 1 "" 1000
		
}	
proc proc_continuous_read {} {
	global dash
	global MAIN_DICT_s10_40g_0
	global anlt_enabled
	global rs_enabled
	
	freeze_buttons
	while {[string match [dashboard_get_property $dash continuous_read checked] "true"]} {
	proc_read_txmac
	proc_read_rxmac
	proc_read_pcs_status
	proc_read_tx_stats
	proc_read_rx_stats
	proc_read_kr4_status
	
	if {$rs_enabled} {
	proc_read_fec_status
	}
	
	
	}
	unfreeze_buttons
}

proc freeze_buttons {} {
	
	global dash
	global anlt_enabled
	global rs_enabled
	global freeze1
	global freeze2
	global freeze3
	global freeze4
	global freeze5
	global freeze6
	global freeze7
	
	global textbox_freeze1
	global textbox_freeze2
	global textbox_freeze3
	global textbox_freeze4
	global textbox_freeze5
	global textbox_freeze6
	global textbox_freeze7
	
	dashboard_set_property $dash launch enabled false
	dashboard_set_property $dash list_jtag enabled false
	dashboard_set_property $dash set_jtag enabled false	
	
	dashboard_set_property $dash full_sys_rst enabled false	
	dashboard_set_property $dash soft_txp_rst enabled false	
	dashboard_set_property $dash soft_rxp_rst enabled false	

	dashboard_set_property $dash read_pcs_status enabled false	
	dashboard_set_property $dash eio_sloop enabled false

	dashboard_set_property $dash read_txmac enabled false	
	dashboard_set_property $dash read_rxmac enabled false

	dashboard_set_property $dash read_tx_stats enabled false	
	dashboard_set_property $dash read_rx_stats enabled false	
	dashboard_set_property $dash reset_tx_stats enabled false	
	dashboard_set_property $dash reset_rx_stats enabled false	
	
	dashboard_set_property $dash read_kr4_status enabled false
	dashboard_set_property $dash htile_prod enabled false
	
	#dashboard_set_property $dash trigger_adapt_button enabled false
	
	if {$rs_enabled} {
	dashboard_set_property $dash read_fec_status enabled false
	}

	if {$anlt_enabled == 1} {
		
		dashboard_set_property $dash reset_seq enabled false
		dashboard_set_property $dash seq_force enabled false
	}		
	
	set freeze1 [dashboard_get_property $dash pkt_gen_random_gap enabled]
	set freeze2 [dashboard_get_property $dash pkt_gen_no_gap enabled]
	set freeze3 [dashboard_get_property $dash pkt_gen_fixed enabled]
	set freeze4 [dashboard_get_property $dash pkt_gen_incr enabled]
	set freeze5 [dashboard_get_property $dash set_source_add enabled]
	set freeze6 [dashboard_get_property $dash set_dest_add enabled]
	set freeze7 [dashboard_get_property $dash mac_loopback enabled]
	
	set textbox_freeze1 [dashboard_get_property $dash source_Add editable]
	set textbox_freeze2 [dashboard_get_property $dash dest_Add editable]
	set textbox_freeze3 [dashboard_get_property $dash pkt_byte_size_val editable]
	set textbox_freeze4 [dashboard_get_property $dash pkt_num_val editable]
	set textbox_freeze5 [dashboard_get_property $dash pkt_byte_size_begin_val editable]
	set textbox_freeze6 [dashboard_get_property $dash pkt_byte_size_end_val editable]
	set textbox_freeze7 [dashboard_get_property $dash pkt_incr_num_val editable]
	
	dashboard_set_property $dash pkt_gen_random_gap enabled false	
	dashboard_set_property $dash pkt_gen_no_gap enabled false	
	dashboard_set_property $dash pkt_gen_fixed enabled false	
	dashboard_set_property $dash pkt_gen_incr enabled false		
	dashboard_set_property $dash set_source_add enabled false		
	dashboard_set_property $dash set_dest_add enabled false		
	dashboard_set_property $dash mac_loopback enabled false		
	dashboard_set_property $dash pkt_cntrl_en enabled false	
	
	if { [string match [dashboard_get_property $dash pkt_cntrl_en checked] "true"] & [string match [dashboard_get_property $dash mac_loopback checked] "false"] } {
	dashboard_set_property $dash source_Add editable 0
	dashboard_set_property $dash dest_Add editable 0
	dashboard_set_property $dash pkt_byte_size_val editable 0
	dashboard_set_property $dash pkt_num_val editable 0
	dashboard_set_property $dash pkt_byte_size_begin_val editable 0
	dashboard_set_property $dash pkt_byte_size_end_val editable 0
	dashboard_set_property $dash pkt_incr_num_val editable 0
	}
	
}

proc unfreeze_buttons {} {

	global dash
	global anlt_enabled
	global rs_enabled
	global freeze1
	global freeze2
	global freeze3
	global freeze4
	global freeze5
	global freeze6
	global freeze7
	
	global textbox_freeze1
	global textbox_freeze2
	global textbox_freeze3
	global textbox_freeze4
	global textbox_freeze5
	global textbox_freeze6
	global textbox_freeze7
		
	dashboard_set_property $dash launch enabled true
	dashboard_set_property $dash list_jtag enabled true
	dashboard_set_property $dash set_jtag enabled true	
	
	dashboard_set_property $dash full_sys_rst enabled true	
	dashboard_set_property $dash soft_txp_rst enabled true	
	dashboard_set_property $dash soft_rxp_rst enabled true	
	
	dashboard_set_property $dash read_pcs_status enabled true	
	dashboard_set_property $dash eio_sloop enabled true	
	
	dashboard_set_property $dash read_txmac enabled true	
	dashboard_set_property $dash read_rxmac enabled true	
	
	dashboard_set_property $dash read_tx_stats enabled true	
	dashboard_set_property $dash read_rx_stats enabled true	
	dashboard_set_property $dash reset_tx_stats enabled true	
	dashboard_set_property $dash reset_rx_stats enabled true

	dashboard_set_property $dash read_kr4_status enabled true
	dashboard_set_property $dash htile_prod enabled true
	#dashboard_set_property $dash trigger_adapt_button enabled true
	
	if {$rs_enabled} {
	dashboard_set_property $dash read_fec_status enabled true
	}
	
	if {$anlt_enabled == 1} {
		
		dashboard_set_property $dash reset_seq enabled true
		dashboard_set_property $dash seq_force enabled true
	}
	
	dashboard_set_property $dash pkt_gen_random_gap enabled $freeze1 
	dashboard_set_property $dash pkt_gen_no_gap enabled $freeze2
	dashboard_set_property $dash pkt_gen_fixed enabled $freeze3 
	dashboard_set_property $dash pkt_gen_incr enabled $freeze4
	dashboard_set_property $dash set_source_add enabled $freeze5
	dashboard_set_property $dash set_dest_add enabled $freeze6
	dashboard_set_property $dash mac_loopback enabled $freeze7
	
	dashboard_set_property $dash pkt_cntrl_en enabled true
	
	if { [string match [dashboard_get_property $dash pkt_cntrl_en checked] "true"] & [string match [dashboard_get_property $dash mac_loopback checked] "false"] } {
	dashboard_set_property $dash source_Add editable $textbox_freeze1
	dashboard_set_property $dash dest_Add editable $textbox_freeze2
	dashboard_set_property $dash pkt_byte_size_val editable $textbox_freeze3
	dashboard_set_property $dash pkt_num_val editable $textbox_freeze4
	dashboard_set_property $dash pkt_byte_size_begin_val editable $textbox_freeze5
	dashboard_set_property $dash pkt_byte_size_end_val editable $textbox_freeze6
	dashboard_set_property $dash pkt_incr_num_val editable $textbox_freeze7
	
	}
}

proc proc_full_sys_rst {} {
	global dash
	global BASE_LL40G
	
	
	if {[string match [dashboard_get_property $dash full_sys_rst text] "Assert Full System Reset"]} {
		reg_write $BASE_LL40G 0x310 0x1
		dashboard_set_property $dash full_sys_rst text "Deassert Full System Reset"
	} elseif {[string match [dashboard_get_property $dash full_sys_rst text] "Deassert Full System Reset"]} {
		reg_write $BASE_LL40G 0x310 0x0
		dashboard_set_property $dash full_sys_rst text "Assert Full System Reset"
	}
}

proc proc_soft_txp_rst {} {
	global dash
	global BASE_LL40G
	
	
	
	if {[string match [dashboard_get_property $dash soft_txp_rst text] "Assert TX MAC & PCS Reset"]} {
		reg_write $BASE_LL40G 0x310 0x2
		dashboard_set_property $dash soft_txp_rst text "Deassert TX MAC & PCS Reset"
	} elseif {[string match [dashboard_get_property $dash soft_txp_rst text] "Deassert TX MAC & PCS Reset"]} {
		reg_write $BASE_LL40G 0x310 0x0
		dashboard_set_property $dash soft_txp_rst text "Assert TX MAC & PCS Reset"
	}
}

proc proc_soft_rxp_rst {} {
	global dash
	global BASE_LL40G
	
	
	
	if {[string match [dashboard_get_property $dash soft_rxp_rst text] "Assert RX MAC & PCS Reset"]} {
		reg_write $BASE_LL40G 0x310 0x4
		dashboard_set_property $dash soft_rxp_rst text "Deassert RX MAC & PCS Reset"
	} elseif {[string match [dashboard_get_property $dash soft_rxp_rst text] "Deassert RX MAC & PCS Reset"]} {
		reg_write $BASE_LL40G 0x310 0x0
		dashboard_set_property $dash soft_rxp_rst text "Assert RX MAC & PCS Reset"
	}
}
proc proc_read_txmac {} {
	global dash
	
	global MAIN_DICT_s10_40g_0
	
	
	set txmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_TXMAC_LINKFAULT] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
		if {[expr $txmac_value & 0x00000008]} {
			dashboard_set_property $dash force_remote_fault_text text "On"
			} else {
			dashboard_set_property $dash force_remote_fault_text text "Off"
           }
		if {[expr $txmac_value & 0x00000004]} {
			dashboard_set_property $dash disable_remote_fault_text text "On"
			} else {
			dashboard_set_property $dash disable_remote_fault_text text "Off"
           }
		if {[expr $txmac_value & 0x00000002]} {
			dashboard_set_property $dash unidir_remote_link_fault_reporting_text text "On"
			} else {
			dashboard_set_property $dash unidir_remote_link_fault_reporting_text text "Off"
           }
		if {[expr $txmac_value & 0x00000001]} {
			dashboard_set_property $dash link_fault_reporting_text text "On"
			} else {
			dashboard_set_property $dash link_fault_reporting_text text "Off"
           }
	
	set txmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_TXMAC_IPGCOLREM] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]					
	dashboard_set_property $dash idle_col_rem_text text "$txmac_value"
						
	set txmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_TXMAC_MAXSIZECONFIG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]					
	dashboard_set_property $dash max_tx_size_config_text text "$txmac_value"					
						
	set txmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_TXMAC_CONTROL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
		if {[expr $txmac_value & 0x00000002]} {
			dashboard_set_property $dash vlan_detection_tx_text text "Disabled"
			} else {
			dashboard_set_property $dash vlan_detection_tx_text text "Enabled"
           }
}

proc reconfig_reg_read {chan addr offset} {
       
    set chanoffs [expr $offset + (0x800 * $chan)]
    return [reg_read $chanoffs $addr]
}

proc reconfig_reg_write {chan addr offset val} {
        
    set chanoffs [expr $offset + (0x800 * $chan)]
    return [reg_write $chanoffs $addr $val]
}

proc reconfig_reg_rmw {chan addr offset mask val} {
    set value [reconfig_reg_read $chan $addr $offset]
    set value [expr $value & [expr 0xffffffff & ~$mask]] 
    set value [expr $value | $val] 
    reconfig_reg_write $chan $addr $offset $value
}

proc proc_read_rxmac {} {
	global dash
	
	global MAIN_DICT_s10_40g_0
	
	set rxmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_RXMAC_LINKFAULT] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
		if {[expr $rxmac_value & 0x00000001]} {
			dashboard_set_property $dash local_fault_text text "Yes" 
				dashboard_set_property $dash local_fault foregroundColor red
			} else {
			dashboard_set_property $dash local_fault_text text "No"
				dashboard_set_property $dash local_fault foregroundColor black
           }
		if {[expr $rxmac_value & 0x00000002]} {
			dashboard_set_property $dash remote_fault_text text "Yes"
				dashboard_set_property $dash remote_fault foregroundColor red
			} else {
			dashboard_set_property $dash remote_fault_text text "No"
				dashboard_set_property $dash remote_fault foregroundColor black
           }
	
	set rxmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_RXMAC_CRCCONFIG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]					
	if {[expr $rxmac_value & 0x00000001]} {
			dashboard_set_property $dash mac_crc_config_text text "Retained"
			} else {
			dashboard_set_property $dash mac_crc_config_text text "Removed"
           }
		
	set rxmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_RXMAC_CONTROL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
		if {[expr $rxmac_value & 0x00000010]} {
			dashboard_set_property $dash preamble_check_text text "On"
			} else {
			dashboard_set_property $dash preamble_check_text text "Off"
           }
		if {[expr $rxmac_value & 0x00000008]} {
			dashboard_set_property $dash sfd_check_text text "On"
			} else {
			dashboard_set_property $dash sfd_check_text text "Off"
           }
		if {[expr $rxmac_value & 0x00000002]} {
			dashboard_set_property $dash vlan_detection_rx_text text "Disabled"
			} else {
			dashboard_set_property $dash vlan_detection_rx_text text "Enabled"
           }
		   
	set rxmac_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_RXMAC_MAXSIZECONFIG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]					
	dashboard_set_property $dash max_rx_size_config_text text "$rxmac_value"
}

proc ignore_nonce_en {} {
  global BASE_LL40G
  
  set an_c0 [reg_read    $BASE_LL40G 0x00C0]
  set an_c0 [expr $an_c0 | 0x80]
  reg_write   $BASE_LL40G 0x00C0 $an_c0
}

proc ignore_nonce_dis {} {
  global BASE_LL40G
  
  set an_c0 [reg_read    $BASE_LL40G 0x00C0]
  set an_c0 [expr $an_c0 & 0x7F]
  reg_write   $BASE_LL40G 0x00C0 $an_c0
}

proc proc_ignore_nonce {} {
	
	global dash
	global BASE_LL40G
	
	if {[dashboard_get_property $dash ignore_tx_nonce checked]} {
		ignore_nonce_en
		
	} else {
		ignore_nonce_dis
	}	
	
	
}

proc kr_restart {} {
  global BASE_LL40G
  
  set reg [reg_read   $BASE_LL40G 0x00B0]
  reg_write $BASE_LL40G 0x00B0 [expr $reg | 0x7]
}

proc proc_eio_sloop {} {
	global dash
	global BASE_LL40G
	global anlt_enabled
	
	if {[string match [dashboard_get_property $dash eio_sloop text] "Enable Serial PMA Loopback"]} {
		
		reg_write 0x0313 $BASE_LL40G 0xf
		# if {$anlt_enabled} {
			# #ignore_nonce_en
			# #kr_restart
		# }
		
		after 300
		dashboard_set_property $dash eio_sloop text "Disable Serial PMA Loopback"
		proc_read_pcs_status
		if {$anlt_enabled} {
			proc_read_kr4_status
		}
	} elseif {[string match [dashboard_get_property $dash eio_sloop text] "Disable Serial PMA Loopback"]} {
		
		reg_write 0x0313 $BASE_LL40G 0x0
		# if {$anlt_enabled} {
			# #ignore_nonce_dis
			# #kr_restart
		# }
		
		after 300
		dashboard_set_property $dash eio_sloop text "Enable Serial PMA Loopback"
		proc_read_pcs_status
		if {$anlt_enabled} {
			proc_read_kr4_status
		}
	}	
}

proc proc_read_pcs_status {} {
	global dash
	
	global MAIN_DICT_s10_40g_0
	
	proc_read_pcs_status_1
	after 50
	proc_read_pcs_status_1
}

proc proc_read_pcs_status_1 {} {
	global dash
	
	global MAIN_DICT_s10_40g_0
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_WORDLCK] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x312 WORD LOCK $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash wordlock_l0 color green
           } else {
             dashboard_set_property $dash wordlock_l0 color red
           }
	    if {[expr $pcs_status_value & 0x00000002]} {
             dashboard_set_property $dash wordlock_l1 color green
           } else {
             dashboard_set_property $dash wordlock_l1 color red
           }
	    if {[expr $pcs_status_value & 0x00000004]} {
             dashboard_set_property $dash wordlock_l2 color green
           } else {
             dashboard_set_property $dash wordlock_l2 color red
           }
	    if {[expr $pcs_status_value & 0x00000008]} {
             dashboard_set_property $dash wordlock_l3 color green
           } else {
             dashboard_set_property $dash wordlock_l3 color red
           }
		   
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_FREQLOCK] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x321 RX CDR PLL Locked $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash rxcdrplllocked_l0 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l0 color red
           }
	    if {[expr $pcs_status_value & 0x00000002]} {
             dashboard_set_property $dash rxcdrplllocked_l1 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l1 color red
           }
	    if {[expr $pcs_status_value & 0x00000004]} {
             dashboard_set_property $dash rxcdrplllocked_l2 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l2 color red
           }
	    if {[expr $pcs_status_value & 0x00000008]} {
             dashboard_set_property $dash rxcdrplllocked_l3 color green
           } else {
             dashboard_set_property $dash rxcdrplllocked_l3 color red
           }
		   
	proc_read_fifo_status
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYCLK] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x322 PHY CLK $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash txpcsready_stat color green
           } else {
             dashboard_set_property $dash txpcsready_stat color red
           }
	    if {[expr $pcs_status_value & 0x00000002]} {
             dashboard_set_property $dash txpll_stat color green
           } else {
             dashboard_set_property $dash txpll_stat color red
           }
	    if {[expr $pcs_status_value & 0x00000004]} {
             dashboard_set_property $dash rxpll_stat color green
           } else {
             dashboard_set_property $dash rxpll_stat color red
           }
		   
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_FRMERROR] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x323 Frame Error $pcs_status_value"
	dashboard_set_property $dash frameerror_stat text "$pcs_status_value"
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_FALIGNED] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x326 RX PCS Fully Aligned $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash rxpcs_stat color green
           } else {
             dashboard_set_property $dash rxpcs_stat color red
           }
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_AMLOCK] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x328 Alignment Marker $pcs_status_value"
	   if {[expr $pcs_status_value & 0x00000001]} {
            dashboard_set_property $dash amlock_stat color green
          } else {
            dashboard_set_property $dash amlock_stat color red
          }
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_LNDSKWED] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x329 Lanes Deskewed $pcs_status_value"
	    if {[expr $pcs_status_value & 0x00000001]} {
             dashboard_set_property $dash lanesdeskewed_stat color green
           } else {
             dashboard_set_property $dash lanesdeskewed_stat color red
           }
		   
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_RXCLKHZ] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x341 RX Clock $pcs_status_value"
		dashboard_set_property $dash rxclk_stat text [format %u [expr $pcs_status_value * 10] ] 
		
		
		
	
	set pcs_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_TXCLKHZ] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x342 TX Clock $pcs_status_value"
		dashboard_set_property $dash txclk_stat text [format %u [expr $pcs_status_value * 10] ] 

}

proc proc_read_fifo_status {} {
	global dash
	
	global MAIN_DICT_s10_40g_0
	
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x0
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "TX FIFO full $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash tx_fifo_full_l0 color red
           } else {
             dashboard_set_property $dash tx_fifo_full_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash tx_fifo_full_l1 color red
           } else {
             dashboard_set_property $dash tx_fifo_full_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash tx_fifo_full_l2 color red
           } else {
             dashboard_set_property $dash tx_fifo_full_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash tx_fifo_full_l3 color red
           } else {
             dashboard_set_property $dash tx_fifo_full_l3 color green
           }
		   
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x1
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "TX FIFO empty $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash tx_fifo_empty_l0 color red
           } else {
             dashboard_set_property $dash tx_fifo_empty_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash tx_fifo_empty_l1 color red
           } else {
             dashboard_set_property $dash tx_fifo_empty_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash tx_fifo_empty_l2 color red
           } else {
             dashboard_set_property $dash tx_fifo_empty_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash tx_fifo_empty_l3 color red
           } else {
             dashboard_set_property $dash tx_fifo_empty_l3 color green
           }
		   
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x2
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "TX FIFO partial full $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash tx_fifo_pfull_l0 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pfull_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash tx_fifo_pfull_l1 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pfull_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash tx_fifo_pfull_l2 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pfull_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash tx_fifo_pfull_l3 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pfull_l3 color green
           }
		   
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x3
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "TX FIFO partial empty $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash tx_fifo_pempty_l0 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pempty_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash tx_fifo_pempty_l1 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pempty_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash tx_fifo_pempty_l2 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pempty_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash tx_fifo_pempty_l3 color yellow
           } else {
             dashboard_set_property $dash tx_fifo_pempty_l3 color green
           }
		   
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x4
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "RX FIFO full $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash rx_fifo_full_l0 color red
           } else {
             dashboard_set_property $dash rx_fifo_full_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash rx_fifo_full_l1 color red
           } else {
             dashboard_set_property $dash rx_fifo_full_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash rx_fifo_full_l2 color red
           } else {
             dashboard_set_property $dash rx_fifo_full_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash rx_fifo_full_l3 color red
           } else {
             dashboard_set_property $dash rx_fifo_full_l3 color green
           }
		   
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x5
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "RX FIFO empty $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash rx_fifo_empty_l0 color red
           } else {
             dashboard_set_property $dash rx_fifo_empty_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash rx_fifo_empty_l1 color red
           } else {
             dashboard_set_property $dash rx_fifo_empty_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash rx_fifo_empty_l2 color red
           } else {
             dashboard_set_property $dash rx_fifo_empty_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash rx_fifo_empty_l3 color red
           } else {
             dashboard_set_property $dash rx_fifo_empty_l3 color green
           }
		   
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x6
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "RX FIFO partial full $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash rx_fifo_pfull_l0 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pfull_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash rx_fifo_pfull_l1 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pfull_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash rx_fifo_pfull_l2 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pfull_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash rx_fifo_pfull_l3 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pfull_l3 color green
           }
		   
	reg_write [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x7
	set fifo_status_value [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "RX FIFO partial empty $fifo_status_value"
	if {[expr $fifo_status_value & 0x00000001]} {
             dashboard_set_property $dash rx_fifo_pempty_l0 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pempty_l0 color green
           }
	    if {[expr $fifo_status_value & 0x00000002]} {
             dashboard_set_property $dash rx_fifo_pempty_l1 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pempty_l1 color green
           }
	    if {[expr $fifo_status_value & 0x00000004]} {
             dashboard_set_property $dash rx_fifo_pempty_l2 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pempty_l2 color green
           }
	    if {[expr $fifo_status_value & 0x00000008]} {
             dashboard_set_property $dash rx_fifo_pempty_l3 color yellow
           } else {
             dashboard_set_property $dash rx_fifo_pempty_l3 color green
           }

}

proc proc_pkt_gen_random_gap {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_random_gap text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_random_gap text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		#dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		reg_write 0x1010 0x5
	} elseif {[string match [dashboard_get_property $dash pkt_gen_random_gap text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_random_gap text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		#dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x7
	}

}

proc proc_pkt_gen_no_gap {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_no_gap text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_no_gap text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		#dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		reg_write 0x1010 0x85
	} elseif {[string match [dashboard_get_property $dash pkt_gen_no_gap text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_no_gap text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		#dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x87
	}

}

proc proc_pkt_gen_fixed {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_fixed text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_fixed text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		#dashboard_set_property $dash pkt_gen_fixed enabled false	
		dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		set size [dashboard_get_property $dash pkt_byte_size_val text]
		reg_write 0x1008 $size
		set num [dashboard_get_property $dash pkt_num_val text]
		reg_write 0x1009 $num
		reg_write 0x1010 0x55
	} elseif {[string match [dashboard_get_property $dash pkt_gen_fixed text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_fixed text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		#dashboard_set_property $dash pkt_gen_fixed enabled true	
		dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x57
	}

}

proc proc_pkt_gen_incr {} {

global dash

	if {[string match [dashboard_get_property $dash pkt_gen_incr text] "Start Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_incr text "Stop Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled false
		dashboard_set_property $dash mac_loopback enabled false
		dashboard_set_property $dash pkt_gen_random_gap enabled false	
		dashboard_set_property $dash pkt_gen_no_gap enabled false	
		dashboard_set_property $dash pkt_gen_fixed enabled false	
		#dashboard_set_property $dash pkt_gen_incr enabled false			
		dashboard_set_property $dash set_source_add enabled false
		dashboard_set_property $dash set_dest_add enabled false
		
		dashboard_set_property $dash source_Add editable 0 
		dashboard_set_property $dash dest_Add editable 0 
		dashboard_set_property $dash pkt_byte_size_val editable 0 
		dashboard_set_property $dash pkt_num_val editable 0 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 0 
		dashboard_set_property $dash pkt_byte_size_end_val editable 0 
		dashboard_set_property $dash pkt_incr_num_val editable 0
		set begin_size [dashboard_get_property $dash pkt_byte_size_begin_val text]
		set end_size [dashboard_get_property $dash pkt_byte_size_end_val text]
		#reg_write 0x1008 $size
		set end_size_shift [ expr $end_size << 16 ]
		set size [ expr $end_size_shift + $begin_size ]
		reg_write 0x1008 $size
		set num [dashboard_get_property $dash pkt_incr_num_val text]
		reg_write 0x1009 $num
		reg_write 0x1010 0x65
	} elseif {[string match [dashboard_get_property $dash pkt_gen_incr text] "Stop Packet Generator"]} {
		dashboard_set_property $dash pkt_gen_incr text "Start Packet Generator"
		dashboard_set_property $dash pkt_cntrl_en enabled true
		dashboard_set_property $dash mac_loopback enabled true
		dashboard_set_property $dash pkt_gen_random_gap enabled true	
		dashboard_set_property $dash pkt_gen_no_gap enabled true	
		dashboard_set_property $dash pkt_gen_fixed enabled true	
		#dashboard_set_property $dash pkt_gen_incr enabled true	
		dashboard_set_property $dash set_source_add enabled true	
		dashboard_set_property $dash set_dest_add enabled true
		
		dashboard_set_property $dash source_Add editable 1 
		dashboard_set_property $dash dest_Add editable 1 
		dashboard_set_property $dash pkt_byte_size_val editable 1 
		dashboard_set_property $dash pkt_num_val editable 1 
		dashboard_set_property $dash pkt_byte_size_begin_val editable 1 
		dashboard_set_property $dash pkt_byte_size_end_val editable 1 
		dashboard_set_property $dash pkt_incr_num_val editable 1 
		reg_write 0x1010 0x67
	}

}

proc stats_read {base loffset} {
    set hoffset [ expr $loffset + 1 ]

    set low_data [ reg_read $base $loffset ]
    set hi_data  [ reg_read $base $hoffset ]
    set data [ expr { ($hi_data << 32) + $low_data } ]
    return $data
}


proc proc_read_tx_stats {} {
	global dash
	global BASE_LL40G
	global MAIN_DICT_s10_40g_0
	#toolkit_send_message info "Reading TX MAC Statistics Counters"

	#Pausing - TX Shadow Request
	reg_write $BASE_LL40G 0x845 0x4
	
	set tx_count_ll [stats_read $BASE_LL40G 0x800]
		dashboard_set_property $dash cntr_tx_fragments_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x802]
		dashboard_set_property $dash cntr_tx_jabbers_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x804]
		dashboard_set_property $dash cntr_tx_fcs_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x806]
		dashboard_set_property $dash cntr_tx_fcs_err_okpkt_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x808]
		dashboard_set_property $dash cntr_tx_mcast_data_err_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x80A]
		dashboard_set_property $dash cntr_tx_bcast_data_err_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x80C]
		dashboard_set_property $dash cntr_tx_ucast_data_err_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x80E]
		dashboard_set_property $dash cntr_tx_mcast_ctrl_err_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x801]
		dashboard_set_property $dash cntr_tx_bcast_ctrl_err_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x812]
		dashboard_set_property $dash cntr_tx_ucast_ctrl_err_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x814]
		dashboard_set_property $dash cntr_tx_pause_err_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x816]
		dashboard_set_property $dash cntr_tx_64b_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x818]
		dashboard_set_property $dash cntr_tx_65to127b_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x81A]
		dashboard_set_property $dash cntr_tx_128to255b_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x81C]
		dashboard_set_property $dash cntr_tx_256to511b_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x81E]
		dashboard_set_property $dash cntr_tx_512to1023b_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x820]
		dashboard_set_property $dash cntr_tx_1024to1518b_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x822]
		dashboard_set_property $dash cntr_tx_1519tomaxb_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x824]
		dashboard_set_property $dash cntr_tx_oversize_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x826]
		dashboard_set_property $dash cntr_tx_mcast_data_ok_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x828]
		dashboard_set_property $dash cntr_tx_bcast_data_ok_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x82A]
		dashboard_set_property $dash cntr_tx_ucast_data_ok_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x82C]
		dashboard_set_property $dash cntr_tx_mcast_ctrl_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x82E]
		dashboard_set_property $dash cntr_tx_bcast_ctrl_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x830]
		dashboard_set_property $dash cntr_tx_ucast_ctrl_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x832]
		dashboard_set_property $dash cntr_tx_pause_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x834]
		dashboard_set_property $dash cntr_tx_runt_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x860]
		dashboard_set_property $dash cntr_tx_payloadoctetsok_d text "$tx_count_ll"
		
	set tx_count_ll [stats_read $BASE_LL40G 0x862]
		dashboard_set_property $dash cntr_tx_frameoctetsok_d text "$tx_count_ll"
		
	#Un-Pausing - TX Shadow Request
	reg_write $BASE_LL40G 0x845 0x0
}

proc proc_read_rx_stats {} {
	global dash
	global BASE_LL40G
	
	global MAIN_DICT_s10_40g_0
	
	#toolkit_send_message info "Reading RX MAC Statistics Counters"

	#Pausing - TX Shadow Request
	reg_write $BASE_LL40G 0x945 0x4
	
	set rx_count_ll [stats_read $BASE_LL40G 0x900]
		dashboard_set_property $dash cntr_rx_fragments_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x902]
		dashboard_set_property $dash cntr_rx_jabbers_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x904]
		dashboard_set_property $dash cntr_rx_fcs_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x906]
		dashboard_set_property $dash cntr_rx_fcs_err_okpkt_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x908]
		dashboard_set_property $dash cntr_rx_mcast_data_err_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x90A]
		dashboard_set_property $dash cntr_rx_bcast_data_err_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x90C]
		dashboard_set_property $dash cntr_rx_ucast_data_err_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x90E]
		dashboard_set_property $dash cntr_rx_mcast_ctrl_err_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x901]
		dashboard_set_property $dash cntr_rx_bcast_ctrl_err_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x912]
		dashboard_set_property $dash cntr_rx_ucast_ctrl_err_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x914]
		dashboard_set_property $dash cntr_rx_pause_err_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x916]
		dashboard_set_property $dash cntr_rx_64b_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x918]
		dashboard_set_property $dash cntr_rx_65to127b_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x91A]
		dashboard_set_property $dash cntr_rx_128to255b_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x91C]
		dashboard_set_property $dash cntr_rx_256to511b_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x91E]
		dashboard_set_property $dash cntr_rx_512to1023b_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x920]
		dashboard_set_property $dash cntr_rx_1024to1518b_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x922]
		dashboard_set_property $dash cntr_rx_1519tomaxb_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x924]
		dashboard_set_property $dash cntr_rx_oversize_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x926]
		dashboard_set_property $dash cntr_rx_mcast_data_ok_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x928]
		dashboard_set_property $dash cntr_rx_bcast_data_ok_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x92A]
		dashboard_set_property $dash cntr_rx_ucast_data_ok_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x92C]
		dashboard_set_property $dash cntr_rx_mcast_ctrl_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x92E]
		dashboard_set_property $dash cntr_rx_bcast_ctrl_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x930]
		dashboard_set_property $dash cntr_rx_ucast_ctrl_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x932]
		dashboard_set_property $dash cntr_rx_pause_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x934]
		dashboard_set_property $dash cntr_rx_runt_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x960]
		dashboard_set_property $dash cntr_rx_payloadoctetsok_d text "$rx_count_ll"
		
	set rx_count_ll [stats_read $BASE_LL40G 0x962]
		dashboard_set_property $dash cntr_rx_frameoctetsok_d text "$rx_count_ll"
		
	#Un-Pausing - TX Shadow Request
	reg_write $BASE_LL40G 0x945 0x0
}

proc proc_pause_tx_stats {} {
	global dash
	
	global MAIN_DICT_s10_40g_0
	
	if {[string match [dashboard_get_property $dash pause_tx_stats text] "Pause TX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_40g_0 TX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x4
		dashboard_set_property $dash pause_tx_stats text "Unpause TX Statistics Counters Collection"
		dashboard_set_property $dash tx_stats_pause_d text "paused"
	} elseif {[string match [dashboard_get_property $dash pause_tx_stats text] "Unpause TX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_40g_0 TX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x0
		dashboard_set_property $dash pause_tx_stats text "Pause TX Statistics Counters Collection"
		dashboard_set_property $dash tx_stats_pause_d text "unpaused"
	}	
}

proc proc_pause_rx_stats {} {
	global dash
	
	global MAIN_DICT_s10_40g_0
	
	if {[string match [dashboard_get_property $dash pause_rx_stats text] "Pause RX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_40g_0 RX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x4
		dashboard_set_property $dash pause_rx_stats text "Unpause RX Statistics Counters Collection"
		dashboard_set_property $dash rx_stats_pause_d text "paused"
	} elseif {[string match [dashboard_get_property $dash pause_rx_stats text] "Unpause RX Statistics Counters Collection"]} {
		reg_write  [dict get $MAIN_DICT_s10_40g_0 RX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x0
		dashboard_set_property $dash pause_rx_stats text "Pause RX Statistics Counters Collection"
		dashboard_set_property $dash rx_stats_pause_d text "unpaused"
	}	
}

proc proc_clear_tx_stats_parity {} {
	global dash
	global MAIN_DICT_s10_40g_0
	reg_write  [dict get $MAIN_DICT_s10_40g_0 TX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x2
	dashboard_set_property $dash tx_stats_parity_led color black
}

proc proc_clear_rx_stats_parity {} {
	global dash
	global MAIN_DICT_s10_40g_0
	reg_write  [dict get $MAIN_DICT_s10_40g_0 RX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x2
	dashboard_set_property $dash rx_stats_parity_led color black
}

proc proc_reset_tx_stats {} {
	global dash
	global MAIN_DICT_s10_40g_0
	reg_write  [dict get $MAIN_DICT_s10_40g_0 TX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x1
	proc_read_tx_stats
}

proc proc_reset_rx_stats {} {
	global dash
	global MAIN_DICT_s10_40g_0
	reg_write  [dict get $MAIN_DICT_s10_40g_0 RX_REG_STAT_CFG] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x1
	proc_read_rx_stats
}

proc proc_htile_prod_enable {} {
	
global dash
global htile_prod_enabled 

	if { [dashboard_get_property $dash htile_prod checked] } {
		set htile_prod_enabled 1
		
	} else {
		set htile_prod_enabled 0
		
	}

}

proc proc_read_kr4_status {} {
	global dash
	global MAIN_DICT_s10_40g_0
	
	proc_read_kr4_status_1
	after 50
	proc_read_kr4_status_1

}

proc proc_read_kr4_status_1 {} {
	global dash
	global MAIN_DICT_s10_40g_0
	global anlt_enabled
	
	proc_lt_all_status
	
	if {$anlt_enabled} {
	set DATA_KR_04D0 [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04D0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x04D0 $DATA_KR_04D0"
	    if {[expr $DATA_KR_04D0 & 0x00000001]} {
             dashboard_set_property $dash lt_ena_data color "green"
           } else {
             dashboard_set_property $dash lt_ena_data color "red"
           }
	
	set DATA_KR_04B0 [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x04B0 $DATA_KR_04B0"
		if {[expr $DATA_KR_04B0 & 0x00010000]} {
             dashboard_set_property $dash fec_ena_data color "green"
           } else {
             dashboard_set_property $dash fec_ena_data color "red"
           }
		if {[expr $DATA_KR_04B0 & 0x00040000]} {
             dashboard_set_property $dash fec_req_data color "green"
           } else {
             dashboard_set_property $dash fec_req_data color "red"
           }
	
	set DATA_KR_04B1 [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B1] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x04B1 $DATA_KR_04B1"
	    if {[expr $DATA_KR_04B1 & 0x00000001]} {
             dashboard_set_property $dash SEQ_LNK_RDY_LED color "green"
           } else {
             dashboard_set_property $dash SEQ_LNK_RDY_LED color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00000100]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "AN mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00000200]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "LT mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00000400]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "40G Data Mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00002000]} {
             dashboard_set_property $dash SEQ_RECONFG_MODE text "40G FEC Data Mode"
           } else {
		   dashboard_set_property $dash SEQ_RECONFG_MODE text "---"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00002000]} {
			  dashboard_set_property $dash fec_use_data color "green"
           } else {
             dashboard_set_property $dash fec_use_data color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00010000]} {
             dashboard_set_property $dash fec_abi_data color "green"
           } else {
             dashboard_set_property $dash fec_abi_data color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00100000]} {
             dashboard_set_property $dash fec_ena_l0 color "green"
           } else {
             dashboard_set_property $dash fec_ena_l0 color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00200000]} {
             dashboard_set_property $dash fec_ena_l1 color "green"
           } else {
             dashboard_set_property $dash fec_ena_l1 color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00400000]} {
             dashboard_set_property $dash fec_ena_l2 color "green"
           } else {
             dashboard_set_property $dash fec_ena_l2 color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00800000]} {
             dashboard_set_property $dash fec_ena_l3 color "green"
           } else {
             dashboard_set_property $dash fec_ena_l3 color "red"
           }
		   
	set DATA_KR_04C0 [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04C0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x04C0 $DATA_KR_04C0"
	    if {[expr $DATA_KR_04C0 & 0x00000001]} {
             dashboard_set_property $dash an_ena_data color "green"
           } else {
             dashboard_set_property $dash an_ena_data color "red"
           }
		   
	set DATA_KR_04C2 [reg_read [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04C2] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR]]
	#puts "0x04C2 $DATA_KR_04C2"
	    if {[expr $DATA_KR_04C2 & 0x00000004]} {
             dashboard_set_property $dash an_comp_data text "Complete"
           } else {
             dashboard_set_property $dash an_comp_data text "In Progress"
           }
		   
		if {[expr $DATA_KR_04C2 & 0x00000020]} {
             dashboard_set_property $dash an_abi_data text "Able to perform AN"
           } else {
             dashboard_set_property $dash an_abi_data text "Unable to perform AN"
           }
		   
	    if {[expr $DATA_KR_04C2 & 0x00000040]} {
             dashboard_set_property $dash an_stat_data color "green"
           } else {
             dashboard_set_property $dash an_stat_data color "red"
           }
		   
		#if {[expr $DATA_KR_04C2 & 0x00000080]} {
        #     dashboard_set_property $dash lp_an_abi_data text "Able to perform AN"
        #   } else {
        #     dashboard_set_property $dash lp_an_abi_data text "Unable to perform AN"
        #   }
		   
		if {[expr $DATA_KR_04C2 & 0x00000200]} {
             dashboard_set_property $dash seq_an_data text "Failure detected"
           } else {
             dashboard_set_property $dash seq_an_data text "Failure not detected"
           }
		   
		if {[expr $DATA_KR_04C2 & 0x00001000]} {
             dashboard_set_property $dash fi_an_data text "1000BASE-KX"
           } elseif {[expr $DATA_KR_04C2 & 0x00002000]} {
             dashboard_set_property $dash fi_an_data text "10GBASE-KX4"
           } elseif {[expr $DATA_KR_04C2 & 0x00004000]} {
             dashboard_set_property $dash fi_an_data text "10GBASE-KR"
           } elseif {[expr $DATA_KR_04C2 & 0x00008000]} {
             dashboard_set_property $dash fi_an_data text "40GBASE-KR4"
           } elseif {[expr $DATA_KR_04C2 & 0x00010000]} {
             dashboard_set_property $dash fi_an_data text "40GBASE-CR4"
           } elseif {[expr $DATA_KR_04C2 & 0x00020000]} {
             dashboard_set_property $dash fi_an_data text "100GBASE-CR10"
           } else {
			 dashboard_set_property $dash fi_an_data text "---"
		   }

	}
	
}

proc proc_read_fec_status {} {

	global dash
	
	set reg_0xE4 [reg_read 0xE4]
	if {[expr $reg_0xE4 & 0x10] } {
	dashboard_set_property $dash fec_word_align_data color green
	} else {
	dashboard_set_property $dash fec_word_align_data color red
	}
	
	set reg_0xDC [reg_read 0xDC]
	set reg_0xDD [reg_read 0xDD]
	set reg_0xDE [reg_read 0xDE]
	set reg_0xDF [reg_read 0xDF]
	
	set temp0_corrected_blk [split [concat [format %0.8b $reg_0xDF] [format %0.8b $reg_0xDE] [format %0.8b $reg_0xDD] [format %0.8b $reg_0xDC]  ""] " "]
	set temp1_corrected_blk [join $temp0_corrected_blk ""]
	set corrected_codewords [bin2dec $temp1_corrected_blk]
	
	dashboard_set_property $dash corrected_codewords_data text $corrected_codewords
		
	set reg_0xE0 [reg_read 0xE0]
	set reg_0xE1 [reg_read 0xE1]
	set reg_0xE2 [reg_read 0xE2]
	set reg_0xE3 [reg_read 0xE3]
	
	set temp0_uncorrected_blk [split [concat [format %0.8b $reg_0xE3] [format %0.8b $reg_0xE2] [format %0.8b $reg_0xE1] [format %0.8b $reg_0xE0]  ""] " "]
	set temp1_uncorrected_blk [join $temp0_uncorrected_blk ""]
	set uncorrected_codewords [bin2dec $temp1_uncorrected_blk]
	
	dashboard_set_property $dash uncorrected_codewords_data text $uncorrected_codewords
	
}

proc bin2dec bin {
		if {$bin == 0} {
			return 0
		} elseif {[string match -* $bin]} {
			set sign -
			set bin [string range $bin[set bin {}] 1 end]
		} else {
			set sign {}
		}
		return $sign[expr 0b$bin]
	}

proc proc_lt_all_status {} {
	global dash
	global MAIN_DICT_s10_40g_0
	
	
	
	proc_lt_status {0}
	proc_lt_status {1}
	proc_lt_status {2}
	proc_lt_status {3}

}

proc proc_lt_status {chan} {
	global dash
	global MAIN_DICT_s10_40g_0
	global htile_prod_enabled
	
	#set chan 0
	if {$htile_prod_enabled} {
	reconfig_reg_write $chan 0x542 0x4000 0x0
	}
	
	set vod [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_VOD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] ]
	set vod [expr $vod & 0x1f]
	
	set post [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_POST] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]]
	if {$post & 0x40} {
        set post [expr -($post & 0x1f)]
    } else {
        set post [expr $post & 0x1f]
    }
	
	set pre [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_PRE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]]
    if {$pre & 0x20} {
        set pre [expr -($pre & 0x1f)]
    } else {
        set pre [expr $pre & 0x1f]
    }
	dashboard_set_property $dash conv_tx_l$chan text "$vod, $post, $pre"
	#dashboard_set_property $dash conv_tx_l${chan} text "$vod, $post, $pre"
	
	#  Test bus = ADP 171[4:1]=1
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPBLOCK] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x1E 0x16
    
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 5
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
	set vga [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x1F]
	dashboard_set_property $dash conv_vga_l$chan text "$vga"
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 4
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set ctle_dc [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x3F]
	dashboard_set_property $dash conv_ctledc_l$chan text "$ctle_dc"
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 3
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set ctle_ac [expr [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] >> 3] & 0xF]
	dashboard_set_property $dash conv_ctleac_l$chan text "$ctle_ac"
	
	#  Test bus = ADP 171[4:1]=1
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPBLOCK] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x1E 0x16
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 7
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set tap1 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x7F]
    if {$tap1 & 0x40} {
        set tap1 [expr -($tap1 & 0x3f)]
    } else {
        set tap1 [expr $tap1 & 0x3f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 8
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set tap2 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x3F]
    if {$tap2 & 0x20} {
         set tap2 [expr -($tap2 & 0x1f)]
    } else {
       
		set tap2 [expr $tap2 & 0x1f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 9
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set tap3 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x3F]
    if {$tap3 & 0x20} {
        
		set tap3 [expr -($tap3 & 0x1f)]
    } else {
        set tap3 [expr $tap3 & 0x1f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 10
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set tap4 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap4 & 0x10} {
        set tap4 [expr -($tap4 & 0xf)]
    } else {
        
		set tap4 [expr $tap4 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 11
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set tap5 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap5 & 0x10} {
         set tap5 [expr -($tap5 & 0xf)]
    } else {
       
		set tap5 [expr $tap5 & 0xf]
    }
   
    reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 12
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
    set tap6 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap6 & 0x10} {
        set tap6 [expr -($tap6 & 0xf)]
    } else {
        
		set tap6 [expr $tap6 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 13
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
	set tap7 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]] & 0x1F]
	if {$tap7 & 0x10} {
        set tap7 [expr -($tap7 & 0xf)]
    } else {
        
		set tap7 [expr $tap7 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 14
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
	set tap8_tap9 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]]
	set tap8 [expr $tap8_tap9 & 0x7]
	if {$tap8 & 0x4} {
        set tap8 [expr -($tap8 & 0x3)]
    } else {
        
		set tap8 [expr $tap8 & 0x3]
    }
	set tap9 [expr [expr $tap8_tap9 >> 3] & 0xF]
	if {$tap9 & 0x8} {
        set tap9 [expr -($tap9 & 0x7)]
    } else {
        
		set tap9 [expr $tap9 & 0x7]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 15
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
	set tap10_tap11 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]]
	set tap10 [expr $tap10_tap11 & 0xF]
	if {$tap10 & 0x8} {
        set tap10 [expr -($tap10 & 0x7)]
    } else {
        
		set tap10 [expr $tap10 & 0x7]
    }
	set tap11 [expr [expr $tap10_tap11 >> 4] & 0xF]
	if {$tap11 & 0x8} {
        set tap11 [expr -($tap11 & 0x7)]
    } else {
        
		set tap11 [expr $tap11 & 0x7]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 16
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
	set tap12_tap13 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]]
	set tap12 [expr $tap12_tap13 & 0xF]
	if {$tap12 & 0x8} {
        set tap12 [expr -($tap12 & 0x7)]
    } else {
        
		set tap12 [expr $tap12 & 0x7]
    }
	set tap13 [expr [expr $tap12_tap13 >> 4] & 0xF]
	if {$tap13 & 0x8} {
        set tap13 [expr -($tap13 & 0x7)]
    } else {
        
		set tap13 [expr $tap13 & 0x7]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0x3F 17
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO] 0
	set tap14_tap15 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10RECO]]
	set tap14 [expr $tap14_tap15 & 0xF]
	if {$tap14 & 0x8} {
        set tap14 [expr -($tap14 & 0x7)]
    } else {
        
		set tap14 [expr $tap14 & 0x7]
    }
	set tap15 [expr [expr $tap14_tap15 >> 4] & 0xF]
	if {$tap15 & 0x8} {
        set tap15 [expr -($tap15 & 0x7)]
    } else {
        
		set tap15 [expr $tap15 & 0x7]
    }
	
	dashboard_set_property $dash conv_dfe_l$chan text "$tap1, $tap2, $tap3, $tap4, $tap5, $tap6, $tap7, $tap8, $tap9, $tap10, $tap11, $tap12, $tap13, $tap14, $tap15"
	
	if {$htile_prod_enabled} {
	reconfig_reg_write $chan 0x542 0x4000 0x1
	}
}

proc proc_reset_seq {} {
	global dash
	global MAIN_DICT_s10_40g_0
	
	#reconfig_reg_rmw {chan addr offset mask val}
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x1 0x1

}

proc proc_seq_force {} {
	global dash
	global MAIN_DICT_s10_40g_0
	
	if {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "No Force"]} {
	#set val 0x01
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x01 0x01
	} elseif {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "40GBASE-R4"]} {
	#set val 0x41
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x000000f1 0x41
	} elseif {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "40GBASE-KR4/CR4"]} {
	#set val 0x51
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x000000f1 0x51
	} elseif {[string match [dashboard_get_property $dash seq_force_mode selectedItem] "40GBASE-R4 w/FEC"]} {
	#set val 0xc1
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0x000000f1 0xc1
	}

	#reconfig_reg_rmw {chan addr offset mask val}
	#reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_40g_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_40g_0 OFFSET_S10CSR] 0xffffff0e $val

}

proc proc_trigger_adapt {} {
	global dash
	global iadpt_set

	if {[string match [dashboard_get_property $dash trigger_adapt_button text] "Start Adaptation"]} {
		dashboard_set_property $dash trigger_adapt_button text "Stop Adaptation"
		set iadpt_set 1
		proc_trigger_adapt_ll40g
		
	} elseif {[string match [dashboard_get_property $dash trigger_adapt_button text] "Stop Adaptation"]} {
		dashboard_set_property $dash trigger_adapt_button text "Start Adaptation"
		set iadpt_set 0
		proc_trigger_adapt_ll40g
	}
	
	

}
proc proc_trigger_adapt_ll40g {} {
	global ip_sub_variant_option
	
	iadpt_control 0x4000
	iadpt_control 0x4800
	iadpt_control 0x5000
	iadpt_control 0x5800	
	
}

# ================================================================== 
# 	XCVR RECONFIG
# ==================================================================
dict set MAIN_DICT_s10_40g_0 ADDR_LT_ADAPBLOCK 0x171
dict set MAIN_DICT_s10_40g_0 ADDR_LT_ADAPWRITE 0x149
dict set MAIN_DICT_s10_40g_0 ADDR_LT_ADAPREAD 0x17E
dict set MAIN_DICT_s10_40g_0 ADDR_LT_VOD 0x109
dict set MAIN_DICT_s10_40g_0 ADDR_LT_POST 0x105
dict set MAIN_DICT_s10_40g_0 ADDR_LT_PRE 0x107

# ================================================================== 
# 	General 40GBASE-KR4/CR4 Registers
# ==================================================================
#
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04B0	0x00B0
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04B1	0x00B1
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04B2	0x00B2
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04B5	0x00B5
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04B8	0x00B8
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04BB	0x00BB

# ================================================================== 
# 	Auto-negotiation Registers
# ==================================================================
#
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C0	0x00C0
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C1	0x00C1
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C2	0x00C2
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C3	0x00C3
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C4	0x00C4
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C5	0x00C5
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C6	0x00C6
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C7	0x00C7
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C8	0x00C8
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04C9	0x00C9
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04CA	0x00CA
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04CB	0x00CB

# ================================================================== 
# 	Link training Registers
# ==================================================================
#
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04D0	0x00D0
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04D1	0x00D1
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04D2	0x00D2
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04D3	0x00D3
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04D4	0x00D4
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04D5	0x00D5
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04D6	0x00D6

dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E0	0x00E0
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E1	0x00E1
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E2	0x00E2
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E3	0x00E3
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E4	0x00E4
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E5	0x00E5
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E6	0x00E6
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E7	0x00E7
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E8	0x00E8
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04E9	0x00E9
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04EA	0x00EA
dict set MAIN_DICT_s10_40g_0 ADDR_KR_04EB	0x00EB

# ================================================================== 
# 	PHY-PCS Registers
# ==================================================================
#
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_REVID    0x0300
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_SCRTCH   0x0301
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_IPNAME2  0x0302
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_IPNAME1  0x0303
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_IPNAME0  0x0304
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_PMACFG   0x0310
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_WORDLCK  0x0312
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_PMALOOP  0x0313
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFSEL  0x0314
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_PHYFLAG  0x0315
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_FREQLOCK 0x0321
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_PHYCLK   0x0322
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_FRMERROR 0x0323
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_CLRFRMER 0x0324
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_SFTRESET 0x0325
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_FALIGNED 0x0326
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_AMLOCK   0x0328
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_LNDSKWED 0x0329
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_PCSVLANE 0x0330
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_RFCLKHZ  0x0340
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_RXCLKHZ  0x0341
dict set MAIN_DICT_s10_40g_0 ADDR_PHY_TXCLKHZ  0x0342

# ================================================================== 
# 	TX MAC Registers
# ==================================================================
#
#
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_REVID			0x0400
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_SCRATCH			0x0401
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_NAME0			0x0402
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_NAME1			0x0403
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_NAME2			0x0404
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_LINKFAULT		0x0405
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_IPGCOLREM		0x0406
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_MAXSIZECONFIG	0x0407
dict set MAIN_DICT_s10_40g_0 ADDR_TXMAC_CONTROL			0x040A

# ================================================================== 
# 	RX MAC Registers
# ==================================================================
#
#
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_REVID			0x0500
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_SCRATCH			0x0501
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_NAME0			0x0502
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_NAME1			0x0503
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_NAME2			0x0504
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_MAXSIZECONFIG	0x0506
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_CRCCONFIG		0x0507
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_LINKFAULT		0x0508
dict set MAIN_DICT_s10_40g_0 ADDR_RXMAC_CONTROL			0x050A

# ================================================================== 
# 	TX Statistics Registers Base
# ==================================================================
dict set MAIN_DICT_s10_40g_0 TX_BASE_STATS 0x800
dict set MAIN_DICT_s10_40g_0  TX_REG_FRAGMENTS_LO       0x800
dict set MAIN_DICT_s10_40g_0  TX_REG_FRAGMENTS_HI       0x801
dict set MAIN_DICT_s10_40g_0  TX_REG_JABBERS_LO         0x802
dict set MAIN_DICT_s10_40g_0  TX_REG_JABBERS_HI         0x803
dict set MAIN_DICT_s10_40g_0  TX_REG_CRCERR_LO          0x804
dict set MAIN_DICT_s10_40g_0  TX_REG_CRCERR_SIZEOK_HI   0x805
dict set MAIN_DICT_s10_40g_0  TX_REG_CRCERR_SIZEOK_LO   0x806
dict set MAIN_DICT_s10_40g_0  TX_REG_CRCERR_HI          0x807
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_DATA_ERR_LO  0x808
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_DATA_ERR_HI  0x809
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_DATA_ERR_LO  0x80A
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_DATA_ERR_HI  0x80B
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_DATA_ERR_LO  0x80C
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_DATA_ERR_HI  0x80D
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_CTRL_ERR_LO  0x80E
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_CTRL_ERR_HI  0x80F
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_CTRL_ERR_LO  0x810
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_CTRL_ERR_HI  0x811
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_CTRL_ERR_LO  0x812
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_CTRL_ERR_HI  0x813
dict set MAIN_DICT_s10_40g_0  TX_REG_PAUSE_ERR_LO       0x814
dict set MAIN_DICT_s10_40g_0  TX_REG_PAUSE_ERR_HI       0x815
dict set MAIN_DICT_s10_40g_0  TX_REG_64B_LO             0x816
dict set MAIN_DICT_s10_40g_0  TX_REG_64B_HI             0x817
dict set MAIN_DICT_s10_40g_0  TX_REG_65to127B_LO        0x818
dict set MAIN_DICT_s10_40g_0  TX_REG_65to127B_HI        0x819
dict set MAIN_DICT_s10_40g_0  TX_REG_128to255B_LO       0x81A
dict set MAIN_DICT_s10_40g_0  TX_REG_128to255B_HI       0x81B
dict set MAIN_DICT_s10_40g_0  TX_REG_256to511B_LO       0x81C
dict set MAIN_DICT_s10_40g_0  TX_REG_256to511B_HI       0x81D
dict set MAIN_DICT_s10_40g_0  TX_REG_512to1023B_LO      0x81E
dict set MAIN_DICT_s10_40g_0  TX_REG_512to1023B_HI      0x81F
dict set MAIN_DICT_s10_40g_0  TX_REG_1024to1518B_LO     0x820
dict set MAIN_DICT_s10_40g_0  TX_REG_1024to1518B_HI     0x821
dict set MAIN_DICT_s10_40g_0  TX_REG_1519toMAXB_LO      0x822
dict set MAIN_DICT_s10_40g_0  TX_REG_1519toMAXB_HI      0x823
dict set MAIN_DICT_s10_40g_0  TX_REG_OVERSIZE_LO        0x824
dict set MAIN_DICT_s10_40g_0  TX_REG_OVERSIZE_HI        0x825
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_DATA_OK_LO   0x826
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_DATA_OK_HI   0x827
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_DATA_OK_LO   0x828
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_DATA_OK_HI   0x829
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_DATA_OK_LO   0x82A
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_DATA_OK_HI   0x82B
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_CTRL_OK_LO   0x82C
dict set MAIN_DICT_s10_40g_0  TX_REG_MCAST_CTRL_OK_HI   0x82D
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_CTRL_OK_LO   0x82E
dict set MAIN_DICT_s10_40g_0  TX_REG_BCAST_CTRL_OK_HI   0x82F
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_CTRL_OK_LO   0x830
dict set MAIN_DICT_s10_40g_0  TX_REG_UCAST_CTRL_OK_HI   0x831
dict set MAIN_DICT_s10_40g_0  TX_REG_PAUSE_LO          0x832
dict set MAIN_DICT_s10_40g_0  TX_REG_PAUSE_HI          0x833
dict set MAIN_DICT_s10_40g_0  TX_REG_RNT_LO            0x834
dict set MAIN_DICT_s10_40g_0  TX_REG_RNT_HI            0x835

dict set MAIN_DICT_s10_40g_0 TX_REG_STAT_CFG		0x845
dict set MAIN_DICT_s10_40g_0 TX_REG_STAT_STATUS		0x846

# ================================================================== 
# 	RX Statistics Registers Base
# ==================================================================
dict set MAIN_DICT_s10_40g_0 RX_BASE_STATS 0x900
dict set MAIN_DICT_s10_40g_0  RX_REG_FRAGMENTS_LO       0x900
dict set MAIN_DICT_s10_40g_0  RX_REG_FRAGMENTS_HI       0x901
dict set MAIN_DICT_s10_40g_0  RX_REG_JABBERS_LO         0x902
dict set MAIN_DICT_s10_40g_0  RX_REG_JABBERS_HI         0x903
dict set MAIN_DICT_s10_40g_0  RX_REG_CRCERR_LO          0x904
dict set MAIN_DICT_s10_40g_0  RX_REG_CRCERR_SIZEOK_HI   0x905
dict set MAIN_DICT_s10_40g_0  RX_REG_CRCERR_SIZEOK_LO   0x906
dict set MAIN_DICT_s10_40g_0  RX_REG_CRCERR_HI          0x907
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_DATA_ERR_LO  0x908
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_DATA_ERR_HI  0x909
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_DATA_ERR_LO  0x90A
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_DATA_ERR_HI  0x90B
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_DATA_ERR_LO  0x90C
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_DATA_ERR_HI  0x90D
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_CTRL_ERR_LO  0x90E
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_CTRL_ERR_HI  0x90F
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_CTRL_ERR_LO  0x910
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_CTRL_ERR_HI  0x911
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_CTRL_ERR_LO  0x912
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_CTRL_ERR_HI  0x913
dict set MAIN_DICT_s10_40g_0  RX_REG_PAUSE_ERR_LO       0x914
dict set MAIN_DICT_s10_40g_0  RX_REG_PAUSE_ERR_HI       0x915
dict set MAIN_DICT_s10_40g_0  RX_REG_64B_LO             0x916
dict set MAIN_DICT_s10_40g_0  RX_REG_64B_HI             0x917
dict set MAIN_DICT_s10_40g_0  RX_REG_65to127B_LO        0x918
dict set MAIN_DICT_s10_40g_0  RX_REG_65to127B_HI        0x919
dict set MAIN_DICT_s10_40g_0  RX_REG_128to255B_LO       0x91A
dict set MAIN_DICT_s10_40g_0  RX_REG_128to255B_HI       0x91B
dict set MAIN_DICT_s10_40g_0  RX_REG_256to511B_LO       0x91C
dict set MAIN_DICT_s10_40g_0  RX_REG_256to511B_HI       0x91D
dict set MAIN_DICT_s10_40g_0  RX_REG_512to1023B_LO      0x91E
dict set MAIN_DICT_s10_40g_0  RX_REG_512to1023B_HI      0x91F
dict set MAIN_DICT_s10_40g_0  RX_REG_1024to1518B_LO     0x920
dict set MAIN_DICT_s10_40g_0  RX_REG_1024to1518B_HI     0x921
dict set MAIN_DICT_s10_40g_0  RX_REG_1519toMAXB_LO      0x922
dict set MAIN_DICT_s10_40g_0  RX_REG_1519toMAXB_HI      0x923
dict set MAIN_DICT_s10_40g_0  RX_REG_OVERSIZE_LO        0x924
dict set MAIN_DICT_s10_40g_0  RX_REG_OVERSIZE_HI        0x925
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_DATA_OK_LO   0x926
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_DATA_OK_HI   0x927
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_DATA_OK_LO   0x928
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_DATA_OK_HI   0x929
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_DATA_OK_LO   0x92A
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_DATA_OK_HI   0x92B
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_CTRL_OK_LO   0x92C
dict set MAIN_DICT_s10_40g_0  RX_REG_MCAST_CTRL_OK_HI   0x92D
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_CTRL_OK_LO   0x92E
dict set MAIN_DICT_s10_40g_0  RX_REG_BCAST_CTRL_OK_HI   0x92F
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_CTRL_OK_LO   0x930
dict set MAIN_DICT_s10_40g_0  RX_REG_UCAST_CTRL_OK_HI   0x931
dict set MAIN_DICT_s10_40g_0  RX_REG_PAUSE_LO          0x932
dict set MAIN_DICT_s10_40g_0  RX_REG_PAUSE_HI          0x933
dict set MAIN_DICT_s10_40g_0  RX_REG_RNT_LO            0x934
dict set MAIN_DICT_s10_40g_0  RX_REG_RNT_HI            0x935

dict set MAIN_DICT_s10_40g_0 RX_REG_STAT_CFG		0x945
dict set MAIN_DICT_s10_40g_0 RX_REG_STAT_STATUS		0x946

proc proc_create_dash {} {
	
	global dash
	
	widget_label 0 select_ip_option_note select_ip_option "Plotting link monitor user interface ... please wait!!"
	dashboard_set_property $dash select_ip_option_note foregroundColor red
	dashboard_s10_40g_0
	widget_label 0 select_ip_option_note select_ip_option "Link monitor user interface ready to use!!"
	dashboard_set_property $dash select_ip_option_note foregroundColor blue

}